﻿using Resources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace ChangePointSystem.AttributeAdapter
{
    /// <summary>
    /// リスト型で0件だった場合にエラー
    /// </summary>
    public class EnsureOneElementAttribute : ValidationAttribute
    {
        /// <summary>
        /// コンストラクタ
        /// </summary>
        public EnsureOneElementAttribute()
        {
            this.ErrorMessageResourceType = typeof(message);
            this.ErrorMessageResourceName = "E017";

        }

        /// <summary>
        /// 検証
        /// </summary>
        public override bool IsValid(object value)
        {
            var list = value as IList;
            if (list != null)
            {
                return list.Count > 0;
            }
            return false;
        }


    }
}