﻿using Resources;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace ChangePointSystem.AttributeAdapter
{
    /// <summary>
    /// 条件によって必須にする
    /// </summary>
    public class RequiredIfAttribute : ValidationAttribute
    {
        private string PropertyName { get; set; }
        private object DesiredValue { get; set; }

        /// <summary>
        /// コンストラクタ
        /// </summary>
        public RequiredIfAttribute(string propertyName, object desiredvalue)
        {
            PropertyName = propertyName;
            DesiredValue = desiredvalue;

            this.ErrorMessageResourceType = typeof(message);
            this.ErrorMessageResourceName = "E001";
        }

        /// <summary>
        /// 検証
        /// </summary>
        protected override ValidationResult IsValid(object value, ValidationContext context)
        {
            object instance = context.ObjectInstance;
            Type type = instance.GetType();
            Object proprtyvalue = type.GetProperty(PropertyName).GetValue(instance, null);
            if (proprtyvalue.ToString() == DesiredValue.ToString())
            {
                //検証する
                ValidationResult result = (value == null) ? new ValidationResult(String.Format(this.ErrorMessageString,new[] { context.DisplayName }), new[] { context.MemberName }) : ValidationResult.Success;
                return result;
            }
            return ValidationResult.Success;
        }
        

    }
}