﻿using ChangePointSystem.Filter;
using ChangePointSystem.Models;
using ChangePointSystem.Util;
using System.Configuration;

namespace ChangePointSystem.Controllers
{
    /// <summary>
    /// 認証が必要な全てのコントローラのベースクラス
    /// </summary>
    [AuthorizedFilter]
    public class BaseController : AllBaseController
    {
        #region プロパティ
        protected const int defaultRowCount = 50;
        #endregion

        #region コンストラクタ
        public BaseController()
        {
            //ログイン中の場合
            if (StaticUtil.Contains(System.Web.HttpContext.Current.Session, "User")) { 
                //ユーザ情報
                UserModel userModel = (UserModel)System.Web.HttpContext.Current.Session["User"];
                ViewBag.UserModel = userModel;
            }
            // WEB共通メニュー
            ViewBag.CommonMenu = ConfigurationManager.AppSettings["commonMenu.url"];
        }
        #endregion
    }
}