﻿using ChangePointSystem.Models;
using ChangePointSystem.Repository;
using ChangePointSystem.Util;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Drawing.Drawing2D;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.WebPages;


namespace ChangePointSystem.Controllers

{
    [RoutePrefix("CheckResult")]
    public class CheckResultController : BaseController
    {
        [HttpGet]
        public ActionResult Index(string id, String path)
        {

            int changePointIds = Convert.ToInt32(id);

            // 変化点情報取得
            ChangePointRepository changePointRepository = new ChangePointRepository();
            ChangePointViewModel changePoint = changePointRepository.FindChangePointViewById(Convert.ToInt32(id));

            // 画面表示View
            TrainingCheckResultRepository CheckResultRepository = new TrainingCheckResultRepository();
            CheckResultViewModel viewModel = CheckResultRepository.FindCheckResultById(changePointIds);

            //EfuNo.取得
            TrainingResultViewModel TrainingResultViewModel = new TrainingResultViewModel();
            TrainingResultViewModel = CheckResultRepository.FindTrainingResultById(changePointIds);

            if (viewModel == null)
            {
                viewModel = new CheckResultViewModel();
                viewModel.EfuNo1 = TrainingResultViewModel.EfuNo1;
                viewModel.ProductNumber1 = TrainingResultViewModel.ProductNumber1;
                viewModel.CerealLotNo1 = TrainingResultViewModel.CerealLotNo1;
                viewModel.EfuNo2 = TrainingResultViewModel.EfuNo2;
                viewModel.ProductNumber2 = TrainingResultViewModel.ProductNumber2;
                viewModel.CerealLotNo2 = TrainingResultViewModel.CerealLotNo2;
                viewModel.EfuNo3 = TrainingResultViewModel.EfuNo3;
                viewModel.ProductNumber3 = TrainingResultViewModel.ProductNumber3;
                viewModel.CerealLotNo3 = TrainingResultViewModel.CerealLotNo3;
            }

            if (viewModel != null)
            {
                string[] ReconfirmResult_status1 = new string[6] { viewModel.ReconfirmResult1_0, viewModel.ReconfirmResult1_1, viewModel.ReconfirmResult1_2, viewModel.ReconfirmResult1_3, viewModel.ReconfirmResult1_4, viewModel.ReconfirmResult1_5 };
                string[] ReconfirmResult_status2 = new string[6] { viewModel.ReconfirmResult2_0, viewModel.ReconfirmResult2_1, viewModel.ReconfirmResult2_2, viewModel.ReconfirmResult2_3, viewModel.ReconfirmResult2_4, viewModel.ReconfirmResult2_5 };
                string[] ReconfirmResult_status3 = new string[6] { viewModel.ReconfirmResult3_0, viewModel.ReconfirmResult3_1, viewModel.ReconfirmResult3_2, viewModel.ReconfirmResult3_3, viewModel.ReconfirmResult3_4, viewModel.ReconfirmResult3_5 };

                viewModel.row1 = StaticUtil.CheckRow(ReconfirmResult_status1);
                viewModel.row2 = StaticUtil.CheckRow(ReconfirmResult_status2);
                viewModel.row3 = StaticUtil.CheckRow(ReconfirmResult_status3);
            }


            // 確認結果リスト
            ViewBag.CheckResultList = SelectListUtil.GetConfirmResultSelectList();

            // 遷移元パス設定
            if (!String.IsNullOrEmpty(path))
            {
                viewModel.SourcePath = path;

            }

            viewModel.ChangePointId = Convert.ToInt32(changePoint.ChangePointId);
            viewModel.LineLabel = changePoint.LineLabel;
            viewModel.ProcessLabel = changePoint.ProcessLabel;
            viewModel.ChangeTypeLabel = changePoint.ChangeTypeLabel;

            return View(viewModel);
        }

        #region 登録・更新
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Save(CheckResultViewModel viewModel)
        {
            int changePointId = Convert.ToInt32(viewModel.ChangePointId);

            // 変化点情報取得
            ChangePointRepository changePointRepository = new ChangePointRepository();
            ChangePointViewModel ChangePointViewModel = changePointRepository.FindChangePointViewById(Convert.ToInt32(changePointId));

            // 教育情報取得
            TrainingCheckResultRepository CheckResultRepository = new TrainingCheckResultRepository();
            t_training_check_result Training = CheckResultRepository.FindTrainingResult(Convert.ToInt32(changePointId));

            viewModel.LineLabel = ChangePointViewModel.LineLabel;
            viewModel.ProcessLabel = ChangePointViewModel.ProcessLabel;
            viewModel.ChangeTypeLabel = ChangePointViewModel.ChangeTypeLabel;
            //検査確認内容登録


            // 既存の検査確認情報取得
            t_training_check_result checkResult = CheckResultRepository.FindCheckResult(changePointId);
            if (checkResult == null)
            {
                // 検査確認情報新規登録
                checkResult = new t_training_check_result()
                {
                    change_point_id = changePointId,
                    training_check_type = Const.CHECK_TYPE2,
                    efu_no1 = viewModel.EfuNo1,
                    product_number1 = viewModel.ProductNumber1,
                    cereal_lot_no1 = viewModel.CerealLotNo1,
                    efu_remove_confirm1 = Const.EFU_REMOVE_NOT,
                    result1 = viewModel.ReconfirmResult1_0,
                    confirm_user_name1 = viewModel.ConfirmUserName1,
                    reconfirm_result1_1 = viewModel.ReconfirmResult1_1,
                    reconfirm_user_name1_1 = viewModel.ReconfirmUserName1_1,
                    reconfirm_result1_2 = viewModel.ReconfirmResult1_2,
                    reconfirm_user_name1_2 = viewModel.ReconfirmUserName1_2,
                    reconfirm_result1_3 = viewModel.ReconfirmResult1_3,
                    reconfirm_user_name1_3 = viewModel.ReconfirmUserName1_3,
                    reconfirm_result1_4 = viewModel.ReconfirmResult1_4,
                    reconfirm_user_name1_4 = viewModel.ReconfirmUserName1_4,
                    reconfirm_result1_5 = viewModel.ReconfirmResult1_5,
                    reconfirm_user_name1_5 = viewModel.ReconfirmUserName1_5,
                    efu_no2 = viewModel.EfuNo2,
                    product_number2 = viewModel.ProductNumber2,
                    cereal_lot_no2 = viewModel.CerealLotNo2,
                    efu_remove_confirm2 = Const.EFU_REMOVE_NOT,
                    result2 = viewModel.ReconfirmResult2_0,
                    confirm_user_name2 = viewModel.ConfirmUserName2,
                    reconfirm_result2_1 = viewModel.ReconfirmResult2_1,
                    reconfirm_user_name2_1 = viewModel.ReconfirmUserName2_1,
                    reconfirm_result2_2 = viewModel.ReconfirmResult2_2,
                    reconfirm_user_name2_2 = viewModel.ReconfirmUserName2_2,
                    reconfirm_result2_3 = viewModel.ReconfirmResult2_3,
                    reconfirm_user_name2_3 = viewModel.ReconfirmUserName2_3,
                    reconfirm_result2_4 = viewModel.ReconfirmResult2_4,
                    reconfirm_user_name2_4 = viewModel.ReconfirmUserName2_4,
                    reconfirm_result2_5 = viewModel.ReconfirmResult2_5,
                    reconfirm_user_name2_5 = viewModel.ReconfirmUserName2_5,
                    efu_no3 = viewModel.EfuNo3,
                    product_number3 = viewModel.ProductNumber3,
                    cereal_lot_no3 = viewModel.CerealLotNo3,
                    efu_remove_confirm3 = Const.EFU_REMOVE_NOT,
                    result3 = viewModel.ReconfirmResult3_0,
                    confirm_user_name3 = viewModel.ConfirmUserName3,
                    reconfirm_result3_1 = viewModel.ReconfirmResult3_1,
                    reconfirm_user_name3_1 = viewModel.ReconfirmUserName3_1,
                    reconfirm_result3_2 = viewModel.ReconfirmResult3_2,
                    reconfirm_user_name3_2 = viewModel.ReconfirmUserName3_2,
                    reconfirm_result3_3 = viewModel.ReconfirmResult3_3,
                    reconfirm_user_name3_3 = viewModel.ReconfirmUserName3_3,
                    reconfirm_result3_4 = viewModel.ReconfirmResult3_4,
                    reconfirm_user_name3_4 = viewModel.ReconfirmUserName3_4,
                    reconfirm_result3_5 = viewModel.ReconfirmResult3_5,
                    reconfirm_user_name3_5 = viewModel.ReconfirmUserName3_5,
                    ng_detail = viewModel.NgDetail,
                    deal_detail = viewModel.DealDetail
                };

                CheckResultRepository.Add(checkResult);
            }
            else
            {
                // 検査確認情報更新
                checkResult.change_point_id = changePointId;
                checkResult.training_check_type = Const.CHECK_TYPE2;
                checkResult.efu_no1 = viewModel.EfuNo1;
                checkResult.product_number1 = viewModel.ProductNumber1;
                checkResult.cereal_lot_no1 = viewModel.CerealLotNo1;
                checkResult.result1 = viewModel.ReconfirmResult1_0;
                checkResult.confirm_user_name1 = viewModel.ConfirmUserName1;
                checkResult.reconfirm_result1_1 = viewModel.ReconfirmResult1_1;
                checkResult.reconfirm_user_name1_1 = viewModel.ReconfirmUserName1_1;
                checkResult.reconfirm_result1_2 = viewModel.ReconfirmResult1_2;
                checkResult.reconfirm_user_name1_2 = viewModel.ReconfirmUserName1_2;
                checkResult.reconfirm_result1_3 = viewModel.ReconfirmResult1_3;
                checkResult.reconfirm_user_name1_3 = viewModel.ReconfirmUserName1_3;
                checkResult.reconfirm_result1_4 = viewModel.ReconfirmResult1_4;
                checkResult.reconfirm_user_name1_4 = viewModel.ReconfirmUserName1_4;
                checkResult.reconfirm_result1_5 = viewModel.ReconfirmResult1_5;
                checkResult.reconfirm_user_name1_5 = viewModel.ReconfirmUserName1_5;
                checkResult.efu_no2 = viewModel.EfuNo2;
                checkResult.product_number2 = viewModel.ProductNumber2;
                checkResult.cereal_lot_no2 = viewModel.CerealLotNo2;
                checkResult.result2 = viewModel.ReconfirmResult2_0;
                checkResult.confirm_user_name2 = viewModel.ConfirmUserName2;
                checkResult.reconfirm_result2_1 = viewModel.ReconfirmResult2_1;
                checkResult.reconfirm_user_name2_1 = viewModel.ReconfirmUserName2_1;
                checkResult.reconfirm_result2_2 = viewModel.ReconfirmResult2_2;
                checkResult.reconfirm_user_name2_2 = viewModel.ReconfirmUserName2_2;
                checkResult.reconfirm_result2_3 = viewModel.ReconfirmResult2_3;
                checkResult.reconfirm_user_name2_3 = viewModel.ReconfirmUserName2_3;
                checkResult.reconfirm_result2_4 = viewModel.ReconfirmResult2_4;
                checkResult.reconfirm_user_name2_4 = viewModel.ReconfirmUserName2_4;
                checkResult.reconfirm_result2_5 = viewModel.ReconfirmResult2_5;
                checkResult.reconfirm_user_name2_5 = viewModel.ReconfirmUserName2_5;
                checkResult.efu_no3 = viewModel.EfuNo3;
                checkResult.product_number3 = viewModel.ProductNumber3;
                checkResult.cereal_lot_no3 = viewModel.CerealLotNo3;
                checkResult.result3 = viewModel.ReconfirmResult3_0;
                checkResult.confirm_user_name3 = viewModel.ConfirmUserName3;
                checkResult.reconfirm_result3_1 = viewModel.ReconfirmResult3_1;
                checkResult.reconfirm_user_name3_1 = viewModel.ReconfirmUserName3_1;
                checkResult.reconfirm_result3_2 = viewModel.ReconfirmResult3_2;
                checkResult.reconfirm_user_name3_2 = viewModel.ReconfirmUserName3_2;
                checkResult.reconfirm_result3_3 = viewModel.ReconfirmResult3_3;
                checkResult.reconfirm_user_name3_3 = viewModel.ReconfirmUserName3_3;
                checkResult.reconfirm_result3_4 = viewModel.ReconfirmResult3_4;
                checkResult.reconfirm_user_name3_4 = viewModel.ReconfirmUserName3_4;
                checkResult.reconfirm_result3_5 = viewModel.ReconfirmResult3_5;
                checkResult.reconfirm_user_name3_5 = viewModel.ReconfirmUserName3_5;
                checkResult.ng_detail = viewModel.NgDetail;
                checkResult.deal_detail = viewModel.DealDetail;

                CheckResultRepository.Update(checkResult);
            }

            bool isTrainingUpdate = false;
            if (Training.product_number1 != viewModel.ProductNumber1) {
                Training.product_number1 = viewModel.ProductNumber1;
                isTrainingUpdate = true;
            }
            if (Training.product_number2 != viewModel.ProductNumber2)
            {
                Training.product_number2 = viewModel.ProductNumber2;
                isTrainingUpdate = true;
            }
            if (Training.product_number3 != viewModel.ProductNumber3)
            {
                Training.product_number3 = viewModel.ProductNumber3;
                isTrainingUpdate = true;
            }

            if (isTrainingUpdate) {
                CheckResultRepository.Update(Training);
            }

            // 変化点情報状態登録
            ChangePointRepository repository = new ChangePointRepository();
            t_change_point changePoint = repository.FindChangePointById(changePointId);
            Boolean isUpdate = false;


            // 対応状況
            string[][] ReconfirmResult = new string[3][];
            string[] ReconfirmResult_status = new string[3];
            ReconfirmResult[0] = new string[7] { viewModel.EfuNo1, viewModel.ReconfirmResult1_0, viewModel.ReconfirmResult1_1, viewModel.ReconfirmResult1_2, viewModel.ReconfirmResult1_3, viewModel.ReconfirmResult1_4, viewModel.ReconfirmResult1_5 };
            ReconfirmResult[1] = new string[7] { viewModel.EfuNo2, viewModel.ReconfirmResult2_0, viewModel.ReconfirmResult2_1, viewModel.ReconfirmResult2_2, viewModel.ReconfirmResult2_3, viewModel.ReconfirmResult2_4, viewModel.ReconfirmResult2_5 };
            ReconfirmResult[2] = new string[7] { viewModel.EfuNo3, viewModel.ReconfirmResult3_0, viewModel.ReconfirmResult3_1, viewModel.ReconfirmResult3_2, viewModel.ReconfirmResult3_3, viewModel.ReconfirmResult3_4, viewModel.ReconfirmResult3_5 };

            ReconfirmResult_status = StaticUtil.getReconfirmResult(ReconfirmResult);

            bool ChangeStatus = StaticUtil.CheckStatus(viewModel);

            if (changePoint.deal_status != Const.DEAL_STATUS_CODE_WAITE_CONFIRM) {
                if (ReconfirmResult_status.Contains("NO")) {

                }
                else if (ReconfirmResult_status.Contains("NG"))
                {
                    //「39:検査確認NG」に更新
                    if ((changePoint.deal_status == Const.DEAL_STATUS_CODE_TRAINING ||
                        changePoint.deal_status == Const.DEAL_STATUS_CODE_CHECK) && ChangeStatus)
                    {
                        changePoint.deal_status = Const.DEAL_STATUS_CODE_CHECK_NG;
                        isUpdate = true;
                    }
                }
                else if (ReconfirmResult_status.Contains("OK"))
                {
                    if ((changePoint.deal_status == Const.DEAL_STATUS_CODE_TRAINING
                        || changePoint.deal_status == Const.DEAL_STATUS_CODE_CHECK_NG) && ChangeStatus)
                    {
                        // 「検査結果登録状態:登録済」に更新
                        changePoint.check_result_status = Const.REGISTE_STATUS_REGISTE;
                        //「30:検査確認済」に更新
                        changePoint.deal_status = Const.DEAL_STATUS_CODE_CHECK;
                        isUpdate = true;
                    }
                }
            }

            // 変化内容登録状態
            if (Const.REGISTE_STATUS_NOT_REGISTE.Equals(changePoint.check_result_status))
            {
                // 「1:登録済」に更新
                changePoint.check_result_status = Const.REGISTE_STATUS_REGISTE;
                isUpdate = true;
            }

            if ((changePoint.deal_status == Const.DEAL_STATUS_CODE_CHECK || changePoint.deal_status == Const.DEAL_STATUS_CODE_CHECK_NG)
                && !ChangeStatus)
                
            {
                if (changePoint.deal_status == Const.DEAL_STATUS_CODE_CHECK) {
                    // 「検査結果登録状態:登録済」に更新
                    changePoint.confirm_status = Const.REGISTE_STATUS_NOT_REGISTE;
                }
                //「29:教育確認済」に更新
                changePoint.deal_status = Const.DEAL_STATUS_CODE_TRAINING;
                isUpdate = true;
            }
            if (isUpdate)
            {
                repository.Update(changePoint);
            }

            // エフ取外し確認判定
            if (changePoint.deal_status == Const.DEAL_STATUS_CODE_CHECK &&
                ((!String.IsNullOrEmpty(checkResult.efu_no1) && checkResult.efu_remove_confirm1 != Const.EFU_REMOVE_OK) ||
                (!String.IsNullOrEmpty(checkResult.efu_no2) && checkResult.efu_remove_confirm2 != Const.EFU_REMOVE_OK) ||
                (!String.IsNullOrEmpty(checkResult.efu_no3) && checkResult.efu_remove_confirm3 != Const.EFU_REMOVE_OK)))
            {

                return RedirectToAction("Index", "EfuRemove", new
                {
                    id = viewModel.ChangePointId,
                    path = viewModel.SourcePath
                });
            }
            else
            {
                // 遷移元を取得
                PathBean pathData = StaticUtil.GetReturnPath(viewModel.SourcePath, "ChangePoint");

                // 変化点情報ID
                return RedirectToAction("Index", pathData.ReturnPath, new
                {
                    id = viewModel.ChangePointId,
                    path = pathData.SourcePath
                });
            }
        }
        #endregion

        #region 戻る
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Return(CheckResultViewModel viewModel)
        {
            // 遷移元を取得
            PathBean pathData = StaticUtil.GetReturnPath(viewModel.SourcePath, "ChangePoint");

            // 変化点情報ID
            return RedirectToAction("Index", pathData.ReturnPath, new
            {
                id = viewModel.ChangePointId,
                path = pathData.SourcePath
            });
        }
        #endregion

        #region VIS
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult GetFileData(CheckResultViewModel viewModel)
        {
            //webConfigからパスを取得
            string basePath = ConfigurationManager.AppSettings["FilePath"];
            // 今日の日付を取得
            string todayDate = DateTime.Now.ToString("yyyyMMdd");

            // 'files' リストには条件を満たすファイルのフルパスが含まれています
            List<string> files = Directory.GetFiles(basePath, "*", SearchOption.AllDirectories)
           .Where(file => Path.GetFileName(file).IndexOf(todayDate, StringComparison.OrdinalIgnoreCase) >= 0 &&
                          Path.GetFileName(file).IndexOf("VIS", StringComparison.OrdinalIgnoreCase) >= 0 &&
                          Path.GetFileName(file).IndexOf("NG", StringComparison.OrdinalIgnoreCase) < 0)
           .ToList();

            //条件に合致するデータを保存するList
            List<string> Content_1 = new List<string>();
            List<string> Content_2 = new List<string>();
            List<string> Content_3 = new List<string>();

            //最終的な結果を保存するList
            List<string> lastResult_1 = new List<string>(new string[6]);
            List<string> lastResult_2 = new List<string>(new string[6]);
            List<string> lastResult_3 = new List<string>(new string[6]);

            // 変化点情報取得
            ChangePointRepository changePointRepository = new ChangePointRepository();
            ChangePointViewModel changePoint = changePointRepository.FindChangePointViewById(viewModel.ChangePointId);

            viewModel.ChangePointId = Convert.ToInt32(changePoint.ChangePointId);
            viewModel.LineLabel = changePoint.LineLabel;
            viewModel.ProcessLabel = changePoint.ProcessLabel;
            viewModel.ChangeTypeLabel = changePoint.ChangeTypeLabel;

            //ファイルの存在を確認
            if (files.Count != 0)
            {
                // 見つかったファイルを反復処理
                foreach (var filePath in files)
                {
                    string fileContent = "";
                    try
                    {
                        // ファイルの内容を読み取る
                        fileContent = System.IO.File.ReadAllText(filePath);
                    }
                    catch
                    {
                        // 確認結果リスト
                        ViewBag.CheckResultList = SelectListUtil.GetConfirmResultSelectList();

                        // ファイルが存在しません場合、エラーとする
                        ViewBag.ErrorMessage = String.Format(Resources.message.E529);

                        // 変化点情報ID
                        return View("Index", viewModel);
                    }

                    // 一致するデータが見つかったため、処理を行います
                    string[] contentArray = fileContent.Split(new[] { "\r\n" }, StringSplitOptions.RemoveEmptyEntries);
                    //ファイル内容をループし、画面の内容と照合する
                    foreach (string item in contentArray)
                    {
                        string[] contentItem = item.Split(',');
                        //モジュール1の内容と一致する場合
                        if (!string.IsNullOrEmpty(viewModel.ProductNumber1) 
                            && viewModel.ProductNumber1.Contains(contentItem[10]) 
                            && viewModel.ProductNumber1.Contains(contentItem[13]) 
                            && viewModel.ProductNumber1.Contains(contentItem[12])
                            && contentItem[7] != Const.FILE_RESULT_NO)
                        {
                            //条件に合致するデータをListに保存
                            Content_1.Add(item);
                        }
                        //モジュール2の内容と一致する場合
                        if (!string.IsNullOrEmpty(viewModel.ProductNumber2) 
                            && viewModel.ProductNumber2.Contains(contentItem[10]) 
                            && viewModel.ProductNumber2.Contains(contentItem[13]) 
                            && viewModel.ProductNumber2.Contains(contentItem[12])
                            && contentItem[7] != Const.FILE_RESULT_NO)
                        {
                            //条件に合致するデータをListに保存
                            Content_2.Add(item);
                        }
                        //モジュール3の内容と一致する場合
                        if (!string.IsNullOrEmpty(viewModel.ProductNumber3) 
                            && viewModel.ProductNumber3.Contains(contentItem[10]) 
                            && viewModel.ProductNumber3.Contains(contentItem[13]) 
                            && viewModel.ProductNumber3.Contains(contentItem[12])
                            && contentItem[7] != Const.FILE_RESULT_NO)
                        {
                            //条件に合致するデータをListに保存
                            Content_3.Add(item);
                        }
                    }
                }


                //Dataを取得後、モジュール1の処理
                if (Content_1.Count != 0)
                {
                    // LINQを使用して並べ替える
                    var sortedList1 = Content_1
                        .Select(s => new
                        {
                            OriginalString = s.Split(',')[7],
                            DateTime = DateTime.ParseExact(s.Split(',')[38] + s.Split(',')[39], "yyyyMMddHHmmss", null)
                        })
                        .OrderBy(item => item.DateTime)
                        .ThenByDescending(item => item.OriginalString)
                        .Skip(Math.Max(0, Content_1.Count - 6))
                        .ToList();

                    // 結果の数が6つに満たない場合、空のデータで補完する
                    while (sortedList1.Count < 6)
                    {
                        sortedList1.Add(new { OriginalString = "", DateTime = DateTime.MinValue });
                    }

                    //フロントエンドに値を設定
                    for (int i = 0; i < sortedList1.Count; i++)
                    {
                        string result = sortedList1[i].OriginalString;
                        //1の定義された値を修正
                        if (Const.FILE_RESULT_OK.Equals(result) || Const.FILE_RESULT_REOK.Equals(result))
                        {
                            lastResult_1[i] = Const.CONFIRM_RESULT_OK;
                        }
                        else if (Const.FILE_RESULT_NG.Equals(result))
                        {
                            lastResult_1[i] = Const.CONFIRM_RESULT_NG;
                        }
                    }
                }

                //Dataを取得後、モジュール2の処理
                if (Content_2.Count != 0)
                {
                    // LINQを使用して並べ替える
                    var sortedList2 = Content_2
                        .Select(s => new
                        {
                            OriginalString = s.Split(',')[7],
                            DateTime = DateTime.ParseExact(s.Split(',')[38] + s.Split(',')[39], "yyyyMMddHHmmss", null)
                        })
                        .OrderBy(item => item.DateTime)
                        .ThenByDescending(item => item.OriginalString)
                        .Skip(Math.Max(0, Content_1.Count - 6))
                        .ToList();

                    // 結果の数が6つに満たない場合、空のデータで補完する
                    while (sortedList2.Count < 6)
                    {
                        sortedList2.Add(new { OriginalString = "", DateTime = DateTime.MinValue });
                    }

                    //フロントエンドに値を設定
                    for (int i = 0; i < sortedList2.Count; i++)
                    {
                        string result = sortedList2[i].OriginalString;
                        //2の定義された値を修正
                        if (Const.FILE_RESULT_OK.Equals(result) || Const.FILE_RESULT_REOK.Equals(result))
                        {
                            lastResult_2[i] = Const.CONFIRM_RESULT_OK;
                        }
                        else if (Const.FILE_RESULT_NG.Equals(result))
                        {
                            lastResult_2[i] = Const.CONFIRM_RESULT_NG;
                        }
                    }
                }


                //Dataを取得後、モジュール3の処理
                if (Content_3.Count != 0)
                {
                    // LINQを使用して並べ替える
                    var sortedList3 = Content_3
                        .Select(s => new
                        {
                            OriginalString = s.Split(',')[7],
                            DateTime = DateTime.ParseExact(s.Split(',')[38] + s.Split(',')[39], "yyyyMMddHHmmss", null)
                        })
                        .OrderBy(item => item.DateTime)
                        .ThenByDescending(item => item.OriginalString)
                        .Skip(Math.Max(0, Content_1.Count - 6))
                        .ToList();

                    // 結果の数が6つに満たない場合、空のデータで補完する
                    while (sortedList3.Count < 6)
                    {
                        sortedList3.Add(new { OriginalString = "", DateTime = DateTime.MinValue });
                    }

                    //フロントエンドに値を設定
                    for (int i = 0; i < sortedList3.Count; i++)
                    {
                        string result = sortedList3[i].OriginalString;
                        //3の定義された値を修正
                        if (Const.FILE_RESULT_OK.Equals(result) || Const.FILE_RESULT_REOK.Equals(result))
                        {
                            lastResult_3[i] = Const.CONFIRM_RESULT_OK;
                        }
                        else if (Const.FILE_RESULT_NG.Equals(result))
                        {
                            lastResult_3[i] = Const.CONFIRM_RESULT_NG;
                        }
                    }
                }

                //設定画面に表示する値
                viewModel.ReconfirmResult1_0 = lastResult_1[0];
                viewModel.ReconfirmResult1_1 = lastResult_1[1];
                viewModel.ReconfirmResult1_2 = lastResult_1[2];
                viewModel.ReconfirmResult1_3 = lastResult_1[3];
                viewModel.ReconfirmResult1_4 = lastResult_1[4];
                viewModel.ReconfirmResult1_5 = lastResult_1[5];

                viewModel.ReconfirmResult2_0 = lastResult_2[0];
                viewModel.ReconfirmResult2_1 = lastResult_2[1];
                viewModel.ReconfirmResult2_2 = lastResult_2[2];
                viewModel.ReconfirmResult2_3 = lastResult_2[3];
                viewModel.ReconfirmResult2_4 = lastResult_2[4];
                viewModel.ReconfirmResult2_5 = lastResult_2[5];

                viewModel.ReconfirmResult3_0 = lastResult_3[0];
                viewModel.ReconfirmResult3_1 = lastResult_3[1];
                viewModel.ReconfirmResult3_2 = lastResult_3[2];
                viewModel.ReconfirmResult3_3 = lastResult_3[3];
                viewModel.ReconfirmResult3_4 = lastResult_3[4];
                viewModel.ReconfirmResult3_5 = lastResult_3[5];

                //ViewModelをクリアする
                if (ModelState.IsValid)
                {
                    ModelState.Clear();
                }  

                // 確認結果リスト
                ViewBag.CheckResultList = SelectListUtil.GetConfirmResultSelectList();

                // 遷移元を取得
                PathBean pathData = StaticUtil.GetReturnPath(viewModel.SourcePath, "ChangePoint");

                return View("Index", viewModel);
            }
            else
            {
                // 確認結果リスト
                ViewBag.CheckResultList = SelectListUtil.GetConfirmResultSelectList();

                // ファイルが存在しません場合、エラーとする
                ViewBag.ErrorMessage = String.Format(Resources.message.E528);
                // 遷移元を取得
                PathBean pathData = StaticUtil.GetReturnPath(viewModel.SourcePath, "ChangePoint");

                // 変化点情報ID
                return View("Index", viewModel);

            }
        }
        #endregion



    }
}