﻿using ChangePointSystem.Models;
using ChangePointSystem.Repository;
using ChangePointSystem.Util;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Globalization;
using System.Linq;
using System.Threading;
using System.Web;
using System.Web.Mvc;

namespace ChangePointSystem.Controllers
{
    [RoutePrefix("Login")]
    public class LoginController : AllBaseController
    {
        [HttpGet]
        public ActionResult Index(String key)
        {
            //Thread.CurrentThread.CurrentCulture = CultureInfo.CreateSpecificCulture("cn");
            //Thread.CurrentThread.CurrentUICulture = new CultureInfo("cn");


            ViewBag.Message = TempData["Message"];

            //セッション情報が存在していた場合
            if (StaticUtil.Contains(System.Web.HttpContext.Current.Session, "User"))
            {
                return RedirectToAction("Index", "TodayList", null);
            }

            //通常ログイン
            return View(new LoginViewModel());
        }

        /// <summary>
        /// ログインPost
        /// </summary>
        /// <param name="model"></param>
        /// <returns></returns>
        [HttpPost]
        public ActionResult Index(LoginViewModel model)
        {
            //Thread.CurrentThread.CurrentCulture = CultureInfo.CreateSpecificCulture("cn");
            //Thread.CurrentThread.CurrentUICulture = new CultureInfo("cn");
            //Validation検証
            if (ModelState.IsValid)
            {
                //パスワードをハッシュ化
                //var hashedPassword = PasswordUtil.GetPassword(model.Password, model.MailAddress);

                //作業者マスタ情報取得(m_work)
                WorkerRepository workerRepository = new WorkerRepository();
                m_worker worker = workerRepository.FindWorker(model.UserId);

                //作業者マスタ情報取得(m_user)
                UserRepository usersRepository = new UserRepository();
                m_user users = usersRepository.FindUser(model.UserId);

                //m_userの中user存在しません
                if (users == null)
                {
                    ViewBag.ErrorMessage = String.Format(Resources.message.E501, new String[] { "作業者ID", "パスワード" });
                }
                else {
                    //データがなかった場合はエラー
                    if (worker == null)
                    {
                        //ログイン失敗
                        ViewBag.ErrorMessage = String.Format(Resources.message.E501, new String[] { "作業者ID", "パスワード" });

                    }
                    else
                    {
                        /*
                        if (model.Password.Equals(worker.password))
                        {
                            //ログイン成功
                            UserRepository userRepository = new UserRepository();
                            m_user user = userRepository.FindUser(model.UserId);

                            //セッション格納
                            Util.Util util = new Util.Util();
                            util.SetSessionUser(user, worker.work_name);

                            //最終ログイン日の設定
                            user.last_login_dt = StaticUtil.GetNow();
                            user.update_dt = StaticUtil.GetNow();
                            user.update_user = user.user_id;
                            userRepository.Update(user);

                            //Topページに遷移
                            return RedirectToAction("Index", "TodayList", null);
                        }
                        else
                        {
                            //パスワード不正
                            ViewBag.ErrorMessage = String.Format(Resources.message.E501, new String[] { "作業者ID", "パスワード" });
                        }
                        */

                        //スキャン登録のため、パスワードは不要とする
                        {
                            UserRepository userRepository = new UserRepository();
                            m_user user = userRepository.FindUser(model.UserId);

                            //セッション格納
                            Util.Util util = new Util.Util();
                            util.SetSessionUser(user, worker.work_name);

                            //最終ログイン日の設定
                            user.last_login_dt = StaticUtil.GetNow();
                            user.update_dt = StaticUtil.GetNow();
                            user.update_user = user.user_id;
                            userRepository.Update(user);

                            //Topページに遷移
                            return RedirectToAction("Index", "TodayList", null);
                        }
                    }

                }

                
            }
            return View(new LoginViewModel());
        }

        /// <summary>
        /// ログアウト
        /// </summary>
        /// <returns></returns>
        [HttpGet]
        public ActionResult Logout()
        {
            //セッションのクリア
            System.Web.HttpContext.Current.Session.Clear();
            
            return RedirectToAction("Index", "Login", null);
        }

        /// <summary>
        /// エラーをログに出力
        /// </summary>
        /// <param name="filterContext"></param>
        protected override void OnException(ExceptionContext filterContext)
        {
            base.OnException(filterContext);
            logger.Error(StaticUtil.getSessionUser().UserId + ":" + filterContext.Exception.Message);
        }


    }
}