﻿using ChangePointSystem.Models;
using ChangePointSystem.Repository;
using ChangePointSystem.Util;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.WebPages;
using static System.Data.Entity.Infrastructure.Design.Executor;

namespace ChangePointSystem.Controllers

{
    [RoutePrefix("ManagerApproval")]
    public class ManagerApprovalController : BaseController
    {
        [HttpGet]
        public ActionResult Index(string ApproverCode)
        {
            ManagerApprovalViewModel viewModel = new ManagerApprovalViewModel(); 
            viewModel.MangerUserid = ApproverCode;

            //未承認の情報を取得
            ManagerApprovalRepository repository = new ManagerApprovalRepository(); 
            IList<ManagerApprovalViewModel> ManagerList = repository.FindManagerList();

            foreach (var item in ManagerList)
            {
                //4M区分の表示ラベルを取得する
                item.ChangeType = StaticUtil.GetChangeTypeLable(item.ChangeType);
            }


            ViewData["list"] = ManagerList;

            return View(viewModel);

        }


        #region 承認
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Save(ChangeDetailViewModel viewModel)
        {
            //変化点情報ID
            int changePointId = Convert.ToInt32(viewModel.ChangePointId);

            // 既存の承認情報取得
            ManagerApprovalRepository repository = new ManagerApprovalRepository();
            ChangePointRepository repositorySearch = new ChangePointRepository();
            t_change_point ApprovalList = repositorySearch.FindChangePointById(changePointId);

            //承認者コードを登録
            ApprovalList.change_point_id = changePointId;
            ApprovalList.approver_code = viewModel.MangerUserid;


            // 「60:管理者承認済」に更新
            ApprovalList.deal_status = Const.DEAL_STATUS_CODE_FINAL_APPROVED;

            // 変化内容承認
            repository.Uodateapprover(ApprovalList);

            // 画面を更新
            return RedirectToAction("Index", "ManagerApproval", new
            {
                path = viewModel.SourcePath,
                ApproverCode = viewModel.MangerUserid
            }); 
        }
        #endregion
    }
}