﻿using ChangePointSystem.Models;
using ChangePointSystem.Repository;
using ChangePointSystem.Util;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.WebPages;

namespace ChangePointSystem.Controllers

{
    [RoutePrefix("ManagerConfirm")]
    public class ManagerConfirmController : BaseController
    {
        [HttpGet]
        public ActionResult Index(String path)
        {
            // 変化点情報取得
            ChangePointRepository changePointRepository = new ChangePointRepository();

            // 画面表示View
            ManagerConfirmViewModel viewModel = new ManagerConfirmViewModel();

            // 遷移元パス設定
            if (!String.IsNullOrEmpty(path))
            {
                viewModel.SourcePath = path;

            }

            return View(viewModel);
        }

        #region 次へ
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Next(ManagerConfirmViewModel viewModel)
        {
            int changePointId = Convert.ToInt32(viewModel.ChangePointId);
            // 管理者コードチェック
            UserRepository userRepository = new UserRepository();
            m_user user = userRepository.FindUser(viewModel.ApproverCode);
            if (user == null)
            {
                // 管理者コード存在しない
                ViewBag.ErrorMessage = Resources.message.E515;
                return View("Index", viewModel);
            }
            if (user.position != Const.POSITION_LEADER)
            {
                // 管理者ではない
                ViewBag.ErrorMessage = Resources.message.E516;
                return View("Index", viewModel);
            }
            //// 変化点情報更新
            //ChangePointRepository repository = new ChangePointRepository();
            //t_change_point changePoint = repository.FindChangePointById(changePointId);
            //Boolean isUpdate = false;
            //// 対応状況
            //if (Const.DEAL_STATUS_CODE_FINAL_CONFIRM.Equals(changePoint.deal_status))
            //{
            //    // 管理者承認済に更新
            //    changePoint.deal_status = Const.DEAL_STATUS_CODE_FINAL_APPROVED;
            //    isUpdate = true;
            //}

            //// 管理者コード更新
            //if (!String.IsNullOrEmpty(viewModel.ApproverCode))
            //{
            //    // 管理者コード設定
            //    changePoint.approver_code = viewModel.ApproverCode;
            //    isUpdate = true;
            //}
            //if (isUpdate)
            //{
            //    repository.Update(changePoint);
            //}

            // 検査結果確認画面へ遷移
            return RedirectToAction("Index", "ManagerApproval", new
            {
                path = viewModel.SourcePath,
                ApproverCode=viewModel.ApproverCode
            }) ;
        }
        #endregion

        //#region 戻る
        //[HttpPost]
        //[ValidateAntiForgeryToken]
        //public ActionResult Return(ManagerConfirmViewModel viewModel)
        //{
        //    // 遷移元を取得
        //    PathBean pathData = StaticUtil.GetReturnPath(viewModel.SourcePath, "ChangePoint");

        //    return RedirectToAction("Index", pathData.ReturnPath, new
        //    {
        //        id = viewModel.ChangePointId,
        //        path = pathData.SourcePath
        //    });
        //}
        //#endregion
    }
}