﻿using ChangePointSystem.Models;
using ChangePointSystem.Util;
using System;
using System.Linq;
using System.Web.Mvc;
using System.Web.Routing;
using static ChangePointSystem.Util.Const;

namespace ChangePointSystem.Filter
{
    /// <summary>
    /// 認可処理
    /// </summary>
    public class AuthorizedFilter : FilterAttribute, IAuthorizationFilter
    {
        /// <summary>
        /// 権限値
        /// </summary>
        private object[] Roles { get; set; }

        /// <summary>
        /// コンストラクタ
        /// </summary>
        /// <param name="roles"></param>
        public AuthorizedFilter(params object[] roles)
        {
            this.Roles = roles;
        }

        /// <summary>
        /// 承認が必要なときの処理
        /// </summary>
        /// <param name="filterContext"></param>
        public void OnAuthorization(AuthorizationContext filterContext)
        {
            //アクセス権限なしの時の遷移先
            RedirectToRouteResult redirectResult = new RedirectToRouteResult(
                                new RouteValueDictionary
                                {
                                {"controller", "Login"},
                                {"action", "Index"},
                                });

            if (!StaticUtil.Contains(System.Web.HttpContext.Current.Session, "User"))
            {
                //未ログインの場合、強制的にログインページに遷移
                filterContext.Result = redirectResult;
                return;
            }

            // ログインユーザ情報を取得
            /*
            UserModel user = (UserModel)System.Web.HttpContext.Current.Session["User"];
            CustomerType userType = (CustomerType)Enum.ToObject(typeof(CustomerType), user.CustomerType);

            // 権限判定
            if (!Roles.Contains(userType))
            {
                // メニューへリダイレクト。
                filterContext.Result = redirectResult;
                return;
            }
            */
        }
    }
}