﻿using ChangePointSystem.Util;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Web;
using System.Web.Mvc;

namespace ChangePointSystem.Filter
{
    public class LoggingFilterAttribute : ActionFilterAttribute
    {
        #region プロパティ
        log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        #endregion


        #region before
        /// <summary>
        /// before
        /// </summary>
        public override void OnActionExecuting(ActionExecutingContext filterContext)
        {
            String path = HttpContext.Current.Request.Url.AbsolutePath;
            logger.Info("user:" + StaticUtil.getSessionUser().UserId + " - start:" + path);
            
            filterContext.HttpContext.Trace.Write("(Logging Filter)Action Executing: " +
                filterContext.ActionDescriptor.ActionName);

            base.OnActionExecuting(filterContext);
        }
        #endregion

        #region after
        /// <summary>
        /// after
        /// </summary>
        public override void OnActionExecuted(ActionExecutedContext filterContext)
        {
            String path = HttpContext.Current.Request.Url.AbsolutePath;
            logger.Info("user:" + StaticUtil.getSessionUser().UserId + " - end:" + path);

            if (filterContext.Exception != null)
                filterContext.HttpContext.Trace.Write("(Logging Filter)Exception thrown");

            base.OnActionExecuted(filterContext);
        }
        #endregion

    }
}