﻿using ChangePointSystem.Repository;
using ChangePointSystem.Util;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace ChangePointSystem.Models
{
    /// <summary>
    /// 変化点情報モデル
    /// </summary>
    public class ChangeListViewModel
    {
        public ChangeListViewModel()
        {
        }

        /// <summary>
        /// 変化点情報をセット
        /// </summary>
        /// <param name="entity"></param>
        public ChangeListViewModel(t_change_point entity, m_training_item entity2)
        {
            this.ChangePointId = Convert.ToString(entity.change_point_id);
            this.ManageNo = entity.manage_no;
            this.AccrualDateFrom = entity.accrual_date;
            this.AccrualDateTo = entity.accrual_date;
            this.AccrualDate = entity.accrual_date;
            this.ChangeType = entity.change_type;
            this.LineLabel = entity.line_code;
            this.ProcessLabel = entity.process_code;
            this.ChangeTypeLabel = StaticUtil.GetChangeTypeLable(entity.change_type);
            this.DealStatus = entity.deal_status;
            this.DealStatusLabel = StaticUtil.GetDealStatusLable(entity.deal_status);
            this.ItemContent = entity2.item_content;
        }

        public string ChangePointId { get; set; }
        public Nullable<DateTime> AccrualDateFrom { get; set; }
        public Nullable<DateTime> AccrualDateTo { get; set; }
        public DateTime AccrualDate { get; set; }
        public string ChangeTypeLabel { get; set; }
        public string LineLabel { get; set; }
        public string ProcessLabel { get; set; }
        public string Status { get; set; }
        public string DealStatusLabel { get; set; }

        public string Length { get; set; }
        public string DealStatus { get; set; }
        public string ChangeType { get; set; }
        public string SearchType { get; set; }
        public string WorkType { get; set; }
        public string RangeType { get; set; }
        public string LineCode { get; set; }
        public string ProcessCode { get; set; }
        public string ProductNumber1 { get; set; }
        public string ProductNumber2 { get; set; }
        public string ProductNumber3 { get; set; }
        public string ManageNo { get; set; }

        public string ItemContent { get; set; }
        public string Comment { get; set; }
        public bool fromToday { get; set; }
        public bool isColor { get; set; }
        public bool isTodayList { get; set; }
        public string ChangePointUser { get; set; }
        public string DetailUser { get; set; }
        public string TrainCheckUser { get; set; }
        public string TrainingUser { get; set; }
        public string FinalUser { get; set; }
        public DateTime RegistDt { get; set; }

        public string EfuNo { get; set; }

        public string Work_Name { get; set; }

        public string Training_dt { get; set; }





    }
}