﻿using ChangePointSystem.Repository;
using ChangePointSystem.Util;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace ChangePointSystem.Models
{
    /// <summary>
    /// 変化点情報モデル
    /// </summary>
    public class ChangePointViewModel : BaseViewModel
    {
        public ChangePointViewModel()
        {
        }

        /// <summary>
        /// 変化点情報をセット
        /// </summary>
        /// <param name="entity"></param>
        public ChangePointViewModel(t_change_point entity)
        {
            this.ChangePointId = Convert.ToString(entity.change_point_id);
            this.EfuNo = entity.efu_no;
            this.ManageNo = entity.manage_no;
            this.AccrualDate = entity.accrual_date;
            this.LineCode = entity.line_code;
            this.ProcessCode = entity.process_code;
            this.UserId = entity.user_id;
            this.ChangeType = entity.change_type;
            this.ChangeTypeLabel = StaticUtil.GetChangeTypeLable(entity.change_type);
            this.BeforeAfterType = entity.before_after_type;
            this.BeforeAfterTypeLabel = StaticUtil.GetBeforeAfterLable(entity.before_after_type);
            this.DealStatus = entity.deal_status;
            this.DealStatusLabel = StaticUtil.GetDealStatusLable(entity.deal_status);
            this.DetailStatus = entity.detail_status;
            this.DetailStatusLabel = StaticUtil.GetRetisteStatusLable(entity.detail_status);
            this.TrainingStatus = entity.training_status;
            this.TrainingStatusLabel = StaticUtil.GetRetisteStatusLable(entity.training_status);
            this.TrainingResultStatus = entity.training_result_status;
            this.TrainingResultStatusLabel = StaticUtil.GetRetisteStatusLable(entity.training_result_status);
            this.CheckResultStatus = entity.check_result_status;
            this.CheckResultStatusLabel = StaticUtil.GetRetisteStatusLable(entity.check_result_status);
            this.ConfirmStatus = entity.confirm_status;
            this.ConfirmStatusLabel = StaticUtil.GetRetisteStatusLable(entity.confirm_status);
        }

        public string ChangePointId { get; set; }
        public string EfuNo { get; set; }
        public string ManageNo { get; set; }
        public DateTime AccrualDate { get; set; }
        public string LineCode { get; set; }
        public string LineLabel { get; set; }
        public string ProcessCode { get; set; }
        public string ProcessLabel { get; set; }
        public string UserId { get; set; }
        public string UserName { get; set; }
        public string ChangeType { get; set; }
        public string ChangeTypeLabel { get; set; }
        public string BeforeAfterType { get; set; }
        public string BeforeAfterTypeLabel { get; set; }
        public string DealStatus { get; set; }
        public string DealStatusLabel { get; set; }
        public string DetailStatus { get; set; }
        public string DetailStatusLabel { get; set; }
        public string TrainingStatus { get; set; }
        public string TrainingStatusLabel { get; set; }
        public string TrainingResultStatus { get; set; }
        public string TrainingResultStatusLabel { get; set; }
        public string CheckResultStatus { get; set; }
        public string CheckResultStatusLabel { get; set; }
        public string ConfirmStatus { get; set; }
        public string ConfirmStatusLabel { get; set; }
        public string ChangeDetailFlg { get; set; }

    }
}