﻿using ChangePointSystem.Repository;
using ChangePointSystem.Util;
using NPOI.HPSF;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace ChangePointSystem.Models
{
    /// <summary>
    /// ユーザモデル
    /// </summary>
    public class EfuListViewModel
    {
        public EfuListViewModel()
        {
        }
        /// <summary>
        /// 変化点情報と組織をセット
        /// </summary>
        /// <param name="entity"></param>
        /// <param name="entity2"></param>
        public EfuListViewModel(t_change_point entity, m_line entity2, t_training_check_result entity3)
        {
            this.ChangePointId = Convert.ToString(entity.change_point_id);
            this.AccrualDate = entity.accrual_date;
            this.ProcessCode = entity.process_code;
            this.UserId = entity.user_id;
            this.ChangeType = entity.change_type;
            this.ChangeTypeLabel = StaticUtil.GetChangeTypeLable(entity.change_type);
            this.DealStatus = entity.deal_status;
            this.DealStatusLabel = StaticUtil.GetDealStatusLable(entity.deal_status);
            this.DetailStatus = entity.detail_status;
            this.DetailStatusLabel = StaticUtil.GetRetisteStatusLable(entity.detail_status);
            this.TrainingStatus = entity.training_status;
            this.TrainingStatusLabel = StaticUtil.GetRetisteStatusLable(entity.training_status);
            this.TrainingResultStatus = entity.training_result_status;
            this.TrainingResultStatusLabel = StaticUtil.GetRetisteStatusLable(entity.training_result_status);
            this.CheckResultStatus = entity.check_result_status;
            this.CheckResultStatusLabel = StaticUtil.GetRetisteStatusLable(entity.check_result_status);
            this.ConfirmStatus = entity.confirm_status;
            this.ConfirmStatusLabel = StaticUtil.GetRetisteStatusLable(entity.confirm_status);
            this.LineName = entity2.line_name;
            this.EfuNo1 = entity3.efu_no1;
            this.ProductNumber1 = entity3.product_number1;
            this.CerealLotNo1 = entity3.cereal_lot_no1;
            this.EfuRemoveConfirm1 = entity3.efu_remove_confirm1;
            this.EfuNo2 = entity3.efu_no2;
            this.ProductNumber2 = entity3.product_number2;
            this.CerealLotNo3 = entity3.cereal_lot_no2;
            this.EfuRemoveConfirm2 = entity3.efu_remove_confirm2;
            this.EfuNo3 = entity3.efu_no3;
            this.ProductNumber3 = entity3.product_number3;
            this.CerealLotNo3 = entity3.cereal_lot_no3;
            this.EfuRemoveConfirm3 = entity3.efu_remove_confirm3;
        }
        public string ChangePointId { get; set; }
        public string ManageNo { get; set; }
        public DateTime AccrualDate { get; set; }
        public string LineCode { get; set; }
        public string LineLabel { get; set; }
        public string ProcessCode { get; set; }
        public string ProcessLabel { get; set; }
        public string UserId { get; set; }
        public string UserName { get; set; }
        public string ChangeType { get; set; }
        public string ChangeTypeLabel { get; set; }
        public string DealStatus { get; set; }
        public string DealStatusLabel { get; set; }
        public string DetailStatus { get; set; }
        public string DetailStatusLabel { get; set; }
        public string TrainingStatus { get; set; }
        public string TrainingStatusLabel { get; set; }
        public string TrainingResultStatus { get; set; }
        public string TrainingResultStatusLabel { get; set; }
        public string CheckResultStatus { get; set; }
        public string CheckResultStatusLabel { get; set; }
        public string ConfirmStatus { get; set; }
        public string ConfirmStatusLabel { get; set; }
        public string LineName { get; set; }
        public string EfuNo1 { get; set; }
        public string ProductNumber1 { get; set; }
        public string CerealLotNo1 { get; set; }
        public string EfuRemoveConfirm1 { get; set; }
        public string EfuNo2 { get; set; }
        public string ProductNumber2 { get; set; }
        public string CerealLotNo2 { get; set; }
        public string EfuRemoveConfirm2 { get; set; }

        public string EfuNo3 { get; set; }
        public string ProductNumber3 { get; set; }
        public string CerealLotNo3 { get; set; }
        public string EfuRemoveConfirm3 { get; set; }
        public string EfuList { get; set; }
        public string AccrualDateDisplay { get; set; }
        public bool isAllEfuList { get; set; }
        public int EfuNoCount { get; set; }
        







    }
}