﻿using ChangePointSystem.Repository;
using ChangePointSystem.Util;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace ChangePointSystem.Models
{
    /// <summary>
    /// ユーザモデル
    /// </summary>
    public class ManagerApprovalViewModel
    {
        public ManagerApprovalViewModel()
        {
        }
        /// <summary>
        /// 変化点情報と組織をセット
        /// </summary>
        /// <param name="entity"></param>
        /// <param name="entity2"></param>
        public ManagerApprovalViewModel(t_change_point entity, m_organization entity2, m_training_item entity3)
        {
            this.ChangePointId = Convert.ToString(entity.change_point_id);
            this.ManageNo = entity.manage_no;
            this.AccrualDate = entity.accrual_date;
            this.ProcessCode = entity.process_code;
            this.UserId = entity.user_id;
            this.ChangeType = entity.change_type;
            this.EfuNo = entity.efu_no;
            this.ChangeTypeLabel = StaticUtil.GetChangeTypeLable(entity.change_type);
            this.DealStatus = entity.deal_status;
            this.DealStatusLabel = StaticUtil.GetDealStatusLable(entity.deal_status);
            this.DetailStatus = entity.detail_status;
            this.DetailStatusLabel = StaticUtil.GetRetisteStatusLable(entity.detail_status);
            this.TrainingStatus = entity.training_status;
            this.TrainingStatusLabel = StaticUtil.GetRetisteStatusLable(entity.training_status);
            this.TrainingResultStatus = entity.training_result_status;
            this.TrainingResultStatusLabel = StaticUtil.GetRetisteStatusLable(entity.training_result_status);
            this.CheckResultStatus = entity.check_result_status;
            this.CheckResultStatusLabel = StaticUtil.GetRetisteStatusLable(entity.check_result_status);
            this.ConfirmStatus = entity.confirm_status;
            this.ConfirmStatusLabel = StaticUtil.GetRetisteStatusLable(entity.confirm_status);
            this.organizationCode = Convert.ToString(entity2.organization_code);
            this.organizationName = entity2.organization_name;
            this.ItemContentTraning = entity3.item_content;
        }

        public string ChangePointId { get; set; }
        public string ManageNo { get; set; }
        public DateTime AccrualDate { get; set; }
        public string LineCode { get; set; }
        public string LineLabel { get; set; }
        public string ProcessCode { get; set; }
        public string ProcessLabel { get; set; }
        public string UserId { get; set; }
        public string UserName { get; set; }
        public string ChangeType { get; set; }
        public string EfuNo { get; set; }
        public string ChangeTypeLabel { get; set; }
        public string DealStatus { get; set; }
        public string DealStatusLabel { get; set; }
        public string DetailStatus { get; set; }
        public string DetailStatusLabel { get; set; }
        public string TrainingStatus { get; set; }
        public string TrainingStatusLabel { get; set; }
        public string TrainingResultStatus { get; set; }
        public string TrainingResultStatusLabel { get; set; }
        public string CheckResultStatus { get; set; }
        public string CheckResultStatusLabel { get; set; }
        public string ConfirmStatus { get; set; }
        public string ConfirmStatusLabel { get; set; }
        public string organizationCode { get; set; }
        public string organizationName { get; set; }
        public string ItemContent { get; set; }
        public string Comment { get; set; }
        public string TrainingCheckType { get; set; }
        public string NgDetail { get; set; }
        public string DealDetail { get; set; }
        public string RegistUser { get; set; }
        public System.DateTime RegistDt { get; set; }
        public string UpdateUser { get; set; }
        public System.DateTime UpdateDt { get; set; }
        public string DeleteFlg { get; set; }

        public string MangerUserid { get; set; }
        public string LineName { get; set; }


        #region 変化点教育
        public string EducatorName { get; set; }
        public string AttendeeName { get; set; }
        public string ItemContentTraning { get; set; }

        #endregion

        #region 最終確認
        public string FinalResult1 { get; set; }
        public string FinalResult2 { get; set; }
        public string FinalConfirmUserName { get; set; }
        #endregion

        #region 教育確認
        public string EfuNo1 { get; set; }
        public string ProductNumber1 { get; set; }
        public string CerealLotNo1 { get; set; }
        public string ReconfirmResult1_0 { get; set; }
        public string ConfirmUserId1 { get; set; }
        public string EfuNo2 { get; set; }
        public string ProductNumber2 { get; set; }
        public string CerealLotNo2 { get; set; }
        public string ReconfirmResult2_0 { get; set; }
        public string ConfirmUserId2 { get; set; }
        public string EfuNo3 { get; set; }
        public string ProductNumber3 { get; set; }
        public string CerealLotNo3 { get; set; }
        public string ReconfirmResult3_0 { get; set; }
        public string ConfirmUserId3 { get; set; }
        public string ReconfirmResult1_1 { get; set; }
        public string ReconfirmUserId1_1 { get; set; }
        public string ReconfirmResult1_2 { get; set; }
        public string ReconfirmUserId1_2 { get; set; }
        public string ReconfirmResult1_3 { get; set; }
        public string ReconfirmUserId1_3 { get; set; }
        public string ReconfirmResult1_4 { get; set; }
        public string ReconfirmUserId1_4 { get; set; }
        public string ReconfirmResult1_5 { get; set; }
        public string ReconfirmUserId1_5 { get; set; }
        public string ReconfirmResult2_1 { get; set; }
        public string ReconfirmUserId2_1 { get; set; }
        public string ReconfirmResult2_2 { get; set; }
        public string ReconfirmUserId2_2 { get; set; }
        public string ReconfirmResult2_3 { get; set; }
        public string ReconfirmUserId2_3 { get; set; }
        public string ReconfirmResult2_4 { get; set; }
        public string ReconfirmUserId2_4 { get; set; }
        public string ReconfirmResult2_5 { get; set; }
        public string ReconfirmUserId2_5 { get; set; }
        public string ReconfirmResult3_1 { get; set; }
        public string ReconfirmUserId3_1 { get; set; }
        public string ReconfirmResult3_2 { get; set; }
        public string ReconfirmUserId3_2 { get; set; }
        public string ReconfirmResult3_3 { get; set; }
        public string ReconfirmUserId3_3 { get; set; }
        public string ReconfirmResult3_4 { get; set; }
        public string ReconfirmUserId3_4 { get; set; }
        public string ReconfirmResult3_5 { get; set; }
        public string ReconfirmUserId3_5 { get; set; }
        public string[] TraingResult1List { get; set; }
        public string[] TraingResult2List { get; set; }
        public string[] TraingResult3List { get; set; }
        public System.DateTime Training_dt { get; set; }

        #endregion

        #region 検査確認
        public string ReconfirmResult1_0_Check { get; set; }
        public string EfuRemoveConfirm1 { get; set; }
        public string EfuRemoveConfirm2 { get; set; }
        public string EfuRemoveConfirm3 { get; set; }
        public string ConfirmUserName1_Check { get; set; }
        public string ReconfirmResult1_1_Check { get; set; }
        public string ReconfirmUserName1_1_Check { get; set; }
        public string ReconfirmResult1_2_Check { get; set; }
        public string ReconfirmUserName1_2_Check { get; set; }
        public string ReconfirmResult1_3_Check { get; set; }
        public string ReconfirmUserName1_3_Check { get; set; }
        public string ReconfirmResult1_4_Check { get; set; }
        public string ReconfirmUserName1_4_Check { get; set; }
        public string ReconfirmResult1_5_Check { get; set; }
        public string ReconfirmUserName1_5_Check { get; set; }
        public string ReconfirmResult2_0_Check { get; set; }
        public string ConfirmUserName2_Check { get; set; }
        public string ReconfirmResult2_1_Check { get; set; }
        public string ReconfirmUserName2_1_Check { get; set; }
        public string ReconfirmResult2_2_Check { get; set; }
        public string ReconfirmUserName2_2_Check { get; set; }
        public string ReconfirmResult2_3_Check { get; set; }
        public string ReconfirmUserName2_3_Check { get; set; }
        public string ReconfirmResult2_4_Check { get; set; }
        public string ReconfirmUserName2_4_Check { get; set; }
        public string ReconfirmResult2_5_Check { get; set; }
        public string ReconfirmUserName2_5_Check { get; set; }
        public string ReconfirmResult3_0_Check { get; set; }
        public string ConfirmUserName3_Check { get; set; }
        public string ReconfirmResult3_1_Check { get; set; }
        public string ReconfirmUserName3_1_Check { get; set; }
        public string ReconfirmResult3_2_Check { get; set; }
        public string ReconfirmUserName3_2_Check { get; set; }
        public string ReconfirmResult3_3_Check { get; set; }
        public string ReconfirmUserName3_3_Check { get; set; }
        public string ReconfirmResult3_4_Check { get; set; }
        public string ReconfirmUserName3_4_Check { get; set; }
        public string ReconfirmResult3_5_Check { get; set; }
        public string ReconfirmUserName3_5_Check { get; set; }
        public string[] CheckResult1List { get; set; }
        public string[] CheckResult2List { get; set; }
        public string[] CheckResult3List { get; set; }

        #endregion
    }
}