﻿using ChangePointSystem.Repository;
using ChangePointSystem.Util;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace ChangePointSystem.Models
{
    /// <summary>
    /// ユーザモデル
    /// </summary>
    public class TodayListViewModel
    {
        public TodayListViewModel()
        {
        }
        /// <summary>
        /// 変化点情報と組織をセット
        /// </summary>
        /// <param name="entity"></param>
        /// <param name="entity2"></param>
        public TodayListViewModel(t_change_point entity, m_organization entity2, m_training_item entity3)
        {
            this.ChangePointId = Convert.ToString(entity.change_point_id);
            this.ManageNo = entity.manage_no;
            this.AccrualDate = entity.accrual_date;
            this.ProcessCode = entity.process_code;
            this.UserId = entity.user_id;
            this.ChangeType = entity.change_type;
            this.EfuNo = entity.efu_no;
            this.ChangeTypeLabel = StaticUtil.GetChangeTypeLable(entity.change_type);
            this.DealStatus = entity.deal_status;
            this.DealStatusLabel = StaticUtil.GetDealStatusLable(entity.deal_status);
            this.DetailStatus = entity.detail_status;
            this.DetailStatusLabel = StaticUtil.GetRetisteStatusLable(entity.detail_status);
            this.TrainingStatus = entity.training_status;
            this.TrainingStatusLabel = StaticUtil.GetRetisteStatusLable(entity.training_status);
            this.TrainingResultStatus = entity.training_result_status;
            this.TrainingResultStatusLabel = StaticUtil.GetRetisteStatusLable(entity.training_result_status);
            this.CheckResultStatus = entity.check_result_status;
            this.CheckResultStatusLabel = StaticUtil.GetRetisteStatusLable(entity.check_result_status);
            this.ConfirmStatus = entity.confirm_status;
            this.ConfirmStatusLabel = StaticUtil.GetRetisteStatusLable(entity.confirm_status);
            this.organizationCode = Convert.ToString(entity2.organization_code);
            this.organizationName = entity2.organization_name;
            this.ItemContent = entity3.item_content;
        }
        public string ChangePointId { get; set; }
        public string ManageNo { get; set; }
        public DateTime AccrualDate { get; set; }
        public string LineCode { get; set; }
        public string LineLabel { get; set; }
        public string ProcessCode { get; set; }
        public string ProcessLabel { get; set; }
        public string UserId { get; set; }
        public string UserName { get; set; }
        public string ChangeType { get; set; }
        public string EfuNo { get; set; }
        public string ChangeTypeLabel { get; set; }
        public string DealStatus { get; set; }
        public string DealStatusLabel { get; set; }
        public string DetailStatus { get; set; }
        public string DetailStatusLabel { get; set; }
        public string TrainingStatus { get; set; }
        public string TrainingStatusLabel { get; set; }
        public string TrainingResultStatus { get; set; }
        public string TrainingResultStatusLabel { get; set; }
        public string CheckResultStatus { get; set; }
        public string CheckResultStatusLabel { get; set; }
        public string ConfirmStatus { get; set; }
        public string ConfirmStatusLabel { get; set; }
        public string organizationCode { get; set; }
        public string organizationName { get; set; }
        public string ItemContent { get; set; }
        public string Comment { get; set; }
        public Nullable<System.DateTime> LastViewDt { get; set; }
        public int FinalTimeCount { get; set; }

        public string Training_dt { get; set; }

    }
}