﻿using ChangePointSystem.Repository;
using ChangePointSystem.Util;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace ChangePointSystem.Models
{
    public class TrainingResultViewModel : BaseViewModel
    {

        public TrainingResultViewModel()
        {
        }

        /// <summary>
        /// 変化点情報をセット
        /// </summary>
        /// <param name="entity"></param>
        public TrainingResultViewModel(t_training_check_result entity)
        {
            this.ChangePointId = entity.change_point_id;
            this.TrainingCheckType = entity.training_check_type;
            this.EfuNo1 = entity.efu_no1;
            this.ProductNumber1 = entity.product_number1;
            this.CerealLotNo1 = entity.cereal_lot_no1;
            this.ReconfirmResult1_0 = entity.result1;
            this.ConfirmUserId1 = entity.confirm_user_id1;
            this.EfuNo2 = entity.efu_no2;
            this.ProductNumber2 = entity.product_number2;
            this.CerealLotNo2 = entity.cereal_lot_no2;
            this.ReconfirmResult2_0 = entity.result2;
            this.ConfirmUserId2 = entity.confirm_user_id2;
            this.EfuNo3 = entity.efu_no3;
            this.ProductNumber3 = entity.product_number3;
            this.CerealLotNo3 = entity.cereal_lot_no3;
            this.ReconfirmResult3_0 = entity.result3;
            this.ConfirmUserId3 = entity.confirm_user_id3;
            this.NgDetail = entity.ng_detail;
            this.DealDetail = entity.deal_detail;
            this.RegistUser = entity.regist_user;
            this.RegistDt = entity.regist_dt;
            this.UpdateUser = entity.update_user;
            this.UpdateDt = entity.update_dt;
            this.DeleteFlg = entity.delete_flg;
            this.ReconfirmResult1_1 = entity.reconfirm_result1_1;
            this.ReconfirmUserId1_1 = entity.reconfirm_user_id1_1;
            this.ReconfirmResult1_2 = entity.reconfirm_result1_2;
            this.ReconfirmUserId1_2 = entity.reconfirm_user_id1_2;
            this.ReconfirmResult1_3 = entity.reconfirm_result1_3;
            this.ReconfirmUserId1_3 = entity.reconfirm_user_id1_3;
            this.ReconfirmResult1_4 = entity.reconfirm_result1_4;
            this.ReconfirmUserId1_4 = entity.reconfirm_user_id1_4;
            this.ReconfirmResult1_5 = entity.reconfirm_result1_5;
            this.ReconfirmUserId1_5 = entity.reconfirm_user_id1_5;
            this.ReconfirmResult2_1 = entity.reconfirm_result2_1;
            this.ReconfirmUserId2_1 = entity.reconfirm_user_id2_1;
            this.ReconfirmResult2_2 = entity.reconfirm_result2_2;
            this.ReconfirmUserId2_2 = entity.reconfirm_user_id2_2;
            this.ReconfirmResult2_3 = entity.reconfirm_result2_3;
            this.ReconfirmUserId2_3 = entity.reconfirm_user_id2_3;
            this.ReconfirmResult2_4 = entity.reconfirm_result2_4;
            this.ReconfirmUserId2_4 = entity.reconfirm_user_id2_4;
            this.ReconfirmResult2_5 = entity.reconfirm_result2_5;
            this.ReconfirmUserId2_5 = entity.reconfirm_user_id2_5;
            this.ReconfirmResult3_1 = entity.reconfirm_result3_1;
            this.ReconfirmUserId3_1 = entity.reconfirm_user_id3_1;
            this.ReconfirmResult3_2 = entity.reconfirm_result3_2;
            this.ReconfirmUserId3_2 = entity.reconfirm_user_id3_2;
            this.ReconfirmResult3_3 = entity.reconfirm_result3_3;
            this.ReconfirmUserId3_3 = entity.reconfirm_user_id3_3;
            this.ReconfirmResult3_4 = entity.reconfirm_result3_4;
            this.ReconfirmUserId3_4 = entity.reconfirm_user_id3_4;
            this.ReconfirmResult3_5 = entity.reconfirm_result3_5;
            this.ReconfirmUserId3_5 = entity.reconfirm_user_id3_5;

        }

        public int ChangePointId { get; set; }
        public string LineCode { get; set; }
        public string LineLabel { get; set; }
        public string ProcessCode { get; set; }
        public string ProcessLabel { get; set; }
        public string ChangeType { get; set; }
        public string ChangeTypeLabel { get; set; }
        public string TrainingCheckType { get; set; }
        public string EfuNo1 { get; set; }        
        [StringLength(200)]
        public string ProductNumber1 { get; set; }
        public string CerealLotNo1 { get; set; }
        public string ReconfirmResult1_0 { get; set; }
        public string ConfirmUserId1 { get; set; }
        public string EfuNo2 { get; set; }        
        [StringLength(200)]
        public string ProductNumber2 { get; set; }
        public string CerealLotNo2 { get; set; }
        public string ReconfirmResult2_0 { get; set; }
        public string ConfirmUserId2 { get; set; }
        public string EfuNo3 { get; set; }        
        [StringLength(200)]
        public string ProductNumber3 { get; set; }
        public string CerealLotNo3 { get; set; }
        public string ReconfirmResult3_0 { get; set; }
        public string ConfirmUserId3 { get; set; }
        public string NgDetail { get; set; }
        public string DealDetail { get; set; }
        public string RegistUser { get; set; }
        public System.DateTime RegistDt { get; set; }
        public string UpdateUser { get; set; }
        public System.DateTime UpdateDt { get; set; }
        public string DeleteFlg { get; set; }
        public string ReconfirmResult1_1 { get; set; }
        public string ReconfirmUserId1_1 { get; set; }
        public string ReconfirmResult1_2 { get; set; }
        public string ReconfirmUserId1_2 { get; set; }
        public string ReconfirmResult1_3 { get; set; }
        public string ReconfirmUserId1_3 { get; set; }
        public string ReconfirmResult1_4 { get; set; }
        public string ReconfirmUserId1_4 { get; set; }
        public string ReconfirmResult1_5 { get; set; }
        public string ReconfirmUserId1_5 { get; set; }
        public string ReconfirmResult2_1 { get; set; }
        public string ReconfirmUserId2_1 { get; set; }
        public string ReconfirmResult2_2 { get; set; }
        public string ReconfirmUserId2_2 { get; set; }
        public string ReconfirmResult2_3 { get; set; }
        public string ReconfirmUserId2_3 { get; set; }
        public string ReconfirmResult2_4 { get; set; }
        public string ReconfirmUserId2_4 { get; set; }
        public string ReconfirmResult2_5 { get; set; }
        public string ReconfirmUserId2_5 { get; set; }
        public string ReconfirmResult3_1 { get; set; }
        public string ReconfirmUserId3_1 { get; set; }
        public string ReconfirmResult3_2 { get; set; }
        public string ReconfirmUserId3_2 { get; set; }
        public string ReconfirmResult3_3 { get; set; }
        public string ReconfirmUserId3_3 { get; set; }
        public string ReconfirmResult3_4 { get; set; }
        public string ReconfirmUserId3_4 { get; set; }
        public string ReconfirmResult3_5 { get; set; }
        public string ReconfirmUserId3_5 { get; set; }
        public string row1 { get; set; }
        public string row2 { get; set; }
        public string row3 { get; set; }

    }
}