﻿using ChangePointSystem.Models;
using ChangePointSystem.Util;
using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using System.Web.UI.WebControls;

namespace ChangePointSystem.Repository
{
    /// <summary>
    /// 変化点情報
    /// </summary>
    public class ChangeDetailRepository : Repository<t_change_detail>
    {


        #region 追加
        /// <summary>
        /// 追加
        /// <param name="entity">追加エンティティ</param>
        /// </summary>
        public override bool Add(t_change_detail entity)
        {
            try
            {

                entity.regist_user = StaticUtil.getSessionUser().UserId;
                entity.regist_dt = StaticUtil.GetNow();
                entity.update_user = StaticUtil.getSessionUser().UserId;
                entity.update_dt = StaticUtil.GetNow();
                entity.delete_flg = Const.DELETE_FLG_OFF;

                db.Entry(entity).State = EntityState.Added;
                db.SaveChanges();

                return true;
            }
            catch (Exception e)
            {
                logger.Error(StaticUtil.getSessionUser().UserId + " : " + e);
                return false;

            }
        }
        #endregion

        #region 削除
        /// <summary>
        /// 削除
        /// <param name="entity">削除エンティティ</param>
        /// </summary>
        public override bool Delete(List<t_change_detail> entities)
        {

            try
            {
                db.t_change_detail.RemoveRange(entities);
                db.SaveChanges();

                return true;

            }
            catch (Exception e)
            {
                logger.Error(StaticUtil.getSessionUser().UserId + " : " + e);
                return false;

            }
        }
        #endregion

        #region 変化点内容（複数）
        /// <summary>
        /// 変化点情報IDで、変化点内容を取得
        /// </summary>
        /// <param name="changePointId">変化点情報ID</param>
        /// <returns>変化点内容</returns>
        public List<t_change_detail> FindChangeDetail(int changePointId)
        {
            var m = db.t_change_detail
                .Where(r => r.delete_flg == Const.DELETE_FLG_OFF)
                .Where(r => r.change_point_id == changePointId);
            m = m.Distinct().OrderBy(r => r.priority);

            return m.ToList();
        }
        #endregion
    }
}