﻿using ChangePointSystem.Models;
using ChangePointSystem.Util;
using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using System.Web.UI.WebControls;

namespace ChangePointSystem.Repository
{
    /// <summary>
    /// 変化点情報
    /// </summary>
    public class ManagerApprovalRepository : Repository<t_change_point>
    {


        #region 承認
        /// <summary>
        /// 追加
        /// <param name="entity">追加エンティティ</param>
        /// </summary>
        public bool Uodateapprover(t_change_point entity)
        {
            try
            {

                entity.update_user = StaticUtil.getSessionUser().UserId;
                entity.update_dt = StaticUtil.GetNow();
                entity.delete_flg = Const.DELETE_FLG_OFF;

                db.Entry(entity).State = EntityState.Modified;
                db.SaveChanges();


                ///////4m deal status change record 20241009///////////////////////////
                using (PlusDbContext ctx = new PlusDbContext())
                {
                    // 检查是否存在指定条件的记录
                    var rec = ctx.DealRecords.FirstOrDefault(dr => dr.change_point_id == entity.change_point_id && dr.deal_status == entity.deal_status);

                    if (rec != null)
                    {

                        rec.update_user = StaticUtil.getSessionUser().UserId;
                        rec.update_dt = StaticUtil.GetNow();
                    }
                    else
                    {
                        DealRecord newRecord = new DealRecord
                        {
                            change_point_id = entity.change_point_id,
                            deal_status = entity.deal_status,
                            update_user = StaticUtil.getSessionUser().UserId,
                            update_dt = StaticUtil.GetNow()
                        };
                        ctx.DealRecords.Add(newRecord);
                    }

                    // 保存更改到数据库
                    ctx.SaveChanges();
                }
                ////////////////////////////////

                return true;

            }
            catch (Exception e)
            {
                logger.Error(StaticUtil.getSessionUser().UserId + " : " + e);
                return false;

            }
        }
        #endregion

        #region 未承認の情報を取得
        /// <summary>
        /// 変化点情報IDで、変化点内容を取得
        /// </summary>
        /// <param name="changePointId">変化点情報ID</param>
        /// <returns>変化点内容</returns>
        public List<ManagerApprovalViewModel> FindManagerList()
        {

            #region 
            var queryFinal =
            from a in db.t_change_point
            join q in db.m_line
            on a.line_code equals q.line_code into tempq
            from q in tempq.DefaultIfEmpty()
            join b in db.t_change_detail.Where(x => x.priority == 1)
            on a.change_point_id equals b.change_point_id into temp
            from b in temp.DefaultIfEmpty()
            join c in db.m_process
            on new { a.line_code, a.process_code } equals new { c.line_code, c.process_code }
            join d in db.m_change_item
            on b.item_code equals d.item_code into temp2
            from d in temp2.DefaultIfEmpty()
            join e in db.t_training.Where(x => x.priority == 1)
            on a.change_point_id equals e.change_point_id
            join f in db.m_training_item
            on e.item_code equals f.item_code into temp3
            from f in temp3.DefaultIfEmpty()
            join g in db.t_training_check_result.Where(x => x.training_check_type.Equals("1"))
            on a.change_point_id equals g.change_point_id into temp4
            from g in temp4.DefaultIfEmpty()
            join h in db.t_final_confirm
            on a.change_point_id equals h.change_point_id into temp5
            from h in temp5.DefaultIfEmpty()
            join check in db.t_training_check_result.Where(x => x.training_check_type.Equals("2"))
            on a.change_point_id equals check.change_point_id into temp6
            from check in temp6.DefaultIfEmpty()
            where a.delete_flg == Const.DELETE_FLG_OFF && a.deal_status == Const.DEAL_STATUS_CODE_FINAL_CONFIRM && (a.approver_code == null || a.approver_code == "")
            orderby a.change_point_id
            select new
            {
                q.line_name,
                a.change_point_id,
                c.process_name,
                a.change_type,
                a.deal_status,
                a.efu_no,
                d.item_content,
                b.comment,
                a.manage_no,
                e.educator_name,
                e.attendee_name,
                training_content = f.item_content,
                trainingResult1 = g.result1,
                training_ReconfirmResult1_1 = g.reconfirm_result1_1,
                training_ReconfirmResult1_2 = g.reconfirm_result1_2,
                training_ReconfirmResult1_3 = g.reconfirm_result1_3,
                training_ReconfirmResult1_4 = g.reconfirm_result1_4,
                training_ReconfirmResult1_5 = g.reconfirm_result1_5,
                trainingResult2 = g.result2,
                training_ReconfirmResult2_1 = g.reconfirm_result2_1,
                training_ReconfirmResult2_2 = g.reconfirm_result2_2,
                training_ReconfirmResult2_3 = g.reconfirm_result2_3,
                training_ReconfirmResult2_4 = g.reconfirm_result2_4,
                training_ReconfirmResult2_5 = g.reconfirm_result2_5,
                trainingResult3 = g.result3,
                training_ReconfirmResult3_1 = g.reconfirm_result3_1,
                training_ReconfirmResult3_2 = g.reconfirm_result3_2,
                training_ReconfirmResult3_3 = g.reconfirm_result3_3,
                training_ReconfirmResult3_4 = g.reconfirm_result3_4,
                training_ReconfirmResult3_5 = g.reconfirm_result3_5,
                trainingContent = f.item_content,
                finalResult1 = h.result1,
                finalResult2 = h.result2,
                h.confirm_user_name,
                check.efu_no1,
                check.efu_remove_confirm1,
                check.result1,
                check.confirm_user_name1,
                check.reconfirm_result1_1,
                check.reconfirm_user_name1_1,
                check.reconfirm_result1_2,
                check.reconfirm_user_name1_2,
                check.reconfirm_result1_3,
                check.reconfirm_user_name1_3,
                check.reconfirm_result1_4,
                check.reconfirm_user_name1_4,
                check.reconfirm_result1_5,
                check.reconfirm_user_name1_5,
                check.efu_no2,
                check.efu_remove_confirm2,
                check.result2,
                check.confirm_user_name2,
                check.reconfirm_result2_1,
                check.reconfirm_user_name2_1,
                check.reconfirm_result2_2,
                check.reconfirm_user_name2_2,
                check.reconfirm_result2_3,
                check.reconfirm_user_name2_3,
                check.reconfirm_result2_4,
                check.reconfirm_user_name2_4,
                check.reconfirm_result2_5,
                check.reconfirm_user_name2_5,
                check.efu_no3,
                check.efu_remove_confirm3,
                check.result3,
                check.confirm_user_name3,
                check.reconfirm_result3_1,
                check.reconfirm_user_name3_1,
                check.reconfirm_result3_2,
                check.reconfirm_user_name3_2,
                check.reconfirm_result3_3,
                check.reconfirm_user_name3_3,
                check.reconfirm_result3_4,
                check.reconfirm_user_name3_4,
                check.reconfirm_result3_5,
                check.reconfirm_user_name3_5,
                a.regist_dt,
                training_dt=e.regist_dt,
                g.deal_detail,
            };
            var queryFinalList = queryFinal.ToList();
            List<ManagerApprovalViewModel> List = new List<ManagerApprovalViewModel>();
            int i = 0;
            foreach (var item in queryFinalList)
            {
                List.Insert(i, new ManagerApprovalViewModel());
                List[i].TraingResult1List = new string[] { item.trainingResult1, item.training_ReconfirmResult1_1, item.training_ReconfirmResult1_2, item.training_ReconfirmResult1_3, item.training_ReconfirmResult1_4, item.training_ReconfirmResult1_5 };
                List[i].TraingResult2List = new string[] { item.trainingResult2, item.training_ReconfirmResult2_1, item.training_ReconfirmResult2_2, item.training_ReconfirmResult2_3, item.training_ReconfirmResult2_4, item.training_ReconfirmResult2_5 };
                List[i].TraingResult3List = new string[] { item.trainingResult3, item.training_ReconfirmResult3_1, item.training_ReconfirmResult3_2, item.training_ReconfirmResult3_3, item.training_ReconfirmResult3_4, item.training_ReconfirmResult3_5 };
                List[i].ChangePointId = Convert.ToString(item.change_point_id);
                List[i].LineName = item.line_name;
                List[i].ProcessCode = item.process_name;
                List[i].ChangeType = item.change_type;
                List[i].DealStatus = item.deal_status;
                List[i].EfuNo = item.efu_no;
                List[i].ItemContent = item.item_content;
                List[i].Comment = item.comment;
                List[i].ManageNo = item.manage_no;
                List[i].EducatorName = item.educator_name;
                List[i].AttendeeName = item.attendee_name;
                List[i].ItemContentTraning = item.trainingContent;
                List[i].ReconfirmResult1_0 = item.trainingResult1;
                List[i].ReconfirmResult1_1 = item.training_ReconfirmResult1_1;
                List[i].ReconfirmResult1_2 = item.training_ReconfirmResult1_2;
                List[i].ReconfirmResult1_3 = item.training_ReconfirmResult1_3;
                List[i].ReconfirmResult1_4 = item.training_ReconfirmResult1_4;
                List[i].ReconfirmResult1_5 = item.training_ReconfirmResult1_5;
                List[i].ReconfirmResult2_0 = item.trainingResult2;
                List[i].ReconfirmResult2_1 = item.training_ReconfirmResult2_1;
                List[i].ReconfirmResult2_2 = item.training_ReconfirmResult2_2;
                List[i].ReconfirmResult2_3 = item.training_ReconfirmResult2_3;
                List[i].ReconfirmResult2_4 = item.training_ReconfirmResult2_4;
                List[i].ReconfirmResult2_5 = item.training_ReconfirmResult2_5;
                List[i].ReconfirmResult3_0 = item.trainingResult3;
                List[i].ReconfirmResult3_1 = item.training_ReconfirmResult3_1;
                List[i].ReconfirmResult3_2 = item.training_ReconfirmResult3_2;
                List[i].ReconfirmResult3_3 = item.training_ReconfirmResult3_3;
                List[i].ReconfirmResult3_4 = item.training_ReconfirmResult3_4;
                List[i].ReconfirmResult3_5 = item.training_ReconfirmResult3_5;
                List[i].ItemContentTraning = item.trainingContent;
                List[i].FinalResult1 = item.finalResult1;
                List[i].FinalResult2 = item.finalResult2;
                List[i].FinalConfirmUserName = item.confirm_user_name;
                List[i].CheckResult1List = new string[] { item.result1, item.reconfirm_result1_1, item.reconfirm_result1_2, item.reconfirm_result1_3, item.reconfirm_result1_4, item.reconfirm_result1_5 };
                List[i].CheckResult2List = new string[] { item.result2, item.reconfirm_result2_1, item.reconfirm_result2_2, item.reconfirm_result2_3, item.reconfirm_result2_4, item.reconfirm_result2_5 };
                List[i].CheckResult3List = new string[] { item.result3, item.reconfirm_result3_1, item.reconfirm_result3_2, item.reconfirm_result3_3, item.reconfirm_result3_4, item.reconfirm_result3_5 };
                List[i].EfuNo1 = item.efu_no1;
                List[i].EfuRemoveConfirm1 = item.efu_remove_confirm1;
                List[i].EfuNo2 = item.efu_no2;
                List[i].EfuRemoveConfirm2 = item.efu_remove_confirm2;
                List[i].EfuNo3 = item.efu_no3;
                List[i].EfuRemoveConfirm3 = item.efu_remove_confirm3;
                List[i].ReconfirmResult1_0_Check = item.result1;
                List[i].ConfirmUserName1_Check = item.confirm_user_name1;
                List[i].ReconfirmResult1_1_Check = item.reconfirm_result1_1;
                List[i].ReconfirmUserName1_1_Check = item.reconfirm_user_name1_1;
                List[i].ReconfirmResult1_2_Check = item.reconfirm_result1_2;
                List[i].ReconfirmUserName1_2_Check = item.reconfirm_user_name1_2;
                List[i].ReconfirmResult1_3_Check = item.reconfirm_result1_3;
                List[i].ReconfirmUserName1_3_Check = item.reconfirm_user_name1_3;
                List[i].ReconfirmResult1_4_Check = item.reconfirm_result1_4;
                List[i].ReconfirmUserName1_4_Check = item.reconfirm_user_name1_4;
                List[i].ReconfirmResult1_5_Check = item.reconfirm_result1_5;
                List[i].ReconfirmUserName1_5_Check = item.reconfirm_user_name1_5;
                List[i].ReconfirmResult2_0_Check = item.result2;
                List[i].ConfirmUserName2_Check = item.confirm_user_name2;
                List[i].ReconfirmResult2_1_Check = item.reconfirm_result2_1;
                List[i].ReconfirmUserName2_1_Check = item.reconfirm_user_name2_1;
                List[i].ReconfirmResult2_2_Check = item.reconfirm_result2_2;
                List[i].ReconfirmUserName2_2_Check = item.reconfirm_user_name2_2;
                List[i].ReconfirmResult2_3_Check = item.reconfirm_result2_3;
                List[i].ReconfirmUserName2_3_Check = item.reconfirm_user_name2_3;
                List[i].ReconfirmResult2_4_Check = item.reconfirm_result2_4;
                List[i].ReconfirmUserName2_4_Check = item.reconfirm_user_name2_4;
                List[i].ReconfirmResult2_5_Check = item.reconfirm_result2_5;
                List[i].ReconfirmUserName2_5_Check = item.reconfirm_user_name2_5;
                List[i].ReconfirmResult3_0_Check = item.result3;
                List[i].ConfirmUserName3_Check = item.confirm_user_name3;
                List[i].ReconfirmResult3_1_Check = item.reconfirm_result3_1;
                List[i].ReconfirmUserName3_1_Check = item.reconfirm_user_name3_1;
                List[i].ReconfirmResult3_2_Check = item.reconfirm_result3_2;
                List[i].ReconfirmUserName3_2_Check = item.reconfirm_user_name3_2;
                List[i].ReconfirmResult3_3_Check = item.reconfirm_result3_3;
                List[i].ReconfirmUserName3_3_Check = item.reconfirm_user_name3_3;
                List[i].ReconfirmResult3_4_Check = item.reconfirm_result3_4;
                List[i].ReconfirmUserName3_4_Check = item.reconfirm_user_name3_4;
                List[i].ReconfirmResult3_5_Check = item.reconfirm_result3_5;
                List[i].ReconfirmUserName3_5_Check = item.reconfirm_user_name3_5;
                List[i].RegistDt = item.regist_dt;
                List[i].Training_dt = item.training_dt;
                List[i].DealDetail = item.deal_detail;
                i++;
            }
            #endregion

            return List;
        }
        #endregion


    }
}