﻿using System;
using ChangePointSystem.Models;
using System.Data.Entity;
using ChangePointSystem.Util;
using System.Collections.Generic;

namespace ChangePointSystem.Repository
{
    /// <summary>
    /// DB接続用抽象クラス
    /// </summary>
    public abstract class Repository <TEntity> : IRepository<TEntity>
        where TEntity : class
    {
        #region プロパティ
        protected log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        protected changePointEntities db = new changePointEntities();
        #endregion

        #region コンストラクタ
        protected Repository()
        {
            //SQLログの出力
            db.Database.Log = (log) => logger.Info(log);
        }
        #endregion

        /// <summary>
        /// 追加
        /// </summary>
        /// <param name="entity"></param>
        /// <returns>成功：true / 失敗：false</returns>
        public virtual bool Add(TEntity entity)
        {
            return false;
        }

        /// <summary>
        /// 削除
        /// </summary>
        /// <param name="entity"></param>
        /// <returns>成功：true / 失敗：false</returns>
        public virtual bool Delete(TEntity entity)
        {
            return false;
        }

        /// <summary>
        /// 削除
        /// </summary>
        /// <param name="entities"></param>
        /// <returns>成功：true / 失敗：false</returns>
        public virtual bool Delete(List<TEntity> entities)
        {
            return false;
        }

        /// <summary>
        /// 更新
        /// </summary>
        /// <param name="entity"></param>
        /// <returns>成功：true / 失敗：false</returns>
        public virtual bool Update(TEntity entity)
        {
            return false;
        }
        

    }
}