﻿using ChangePointSystem.Models;
using ChangePointSystem.Util;
using System;
using System.Collections.Generic;
using System.Linq;

namespace ChangePointSystem.Repository
{
    /// <summary>
    /// 変化点教育項目マスタ
    /// </summary>
    public class TrainingItemRepository : Repository<m_training_item>
    {

        /// <summary>
        /// 変化点教育項目を取得し、リスト型で返却する
        /// </summary>
        /// <returns></returns>
        public List<m_training_item> FindTrainingItemList()
        {
            var m = db.m_training_item
                .Where(r => r.delete_flg == Const.DELETE_FLG_OFF);
            m = m.Distinct().OrderBy(r => r.display_order);

            return m.ToList();
        }

        /// <summary>
        /// 変化点教育項目を取得し、コード⇒名称のマップで返却する
        /// </summary>
        /// <returns></returns>
        public Dictionary<String, String> FindTrainingItemMap()
        {
            List<m_training_item> trainingItemList = FindTrainingItemList();
            Dictionary<String, String> trainingItemMap = new Dictionary<String, String>();
            foreach (m_training_item item in trainingItemList)
            {
                trainingItemMap.Add(item.item_content, item.item_code);
            }

            return trainingItemMap;
        }
    }
}