using ChangePointSystem.Models;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data.Entity.Infrastructure;
using System.Linq;
namespace ChangePointSystem.Repository
{
    public class WorkerRepository : Repository<m_user>
    {
        /// <summary>
        /// Ǝ҃}X^̎擾
        /// <param name="workId">ƎID</param>
        /// </summary>
        public m_worker FindWorker(string workId)
        {
            var m = db.m_worker.Select(r => r).Where(r => r.work_id == workId);

            return m.Distinct().FirstOrDefault();
        }

        /// <summary>
        /// Ǝ҂̎擾
        /// <param name="userName">ƎҖ</param>
        /// </summary>
        public IEnumerable<UserModel> FindWorkerBySearch(string userName)

        {

            var priorityDict = new Dictionary<string, int>
            {
                { "4", 1 },
                { "1", 2 },
                { "2", 3 },
                { "3", 4 },
                { "5", 5 },
                { "6", 6 }
            };

            var m =
            from a in db.m_user
            join b in db.m_worker
            on a.user_id equals b.work_id into temp
            from b in temp.DefaultIfEmpty()
            select new
            {
                a.user_id,
                a.position,
                b.work_name
            };

            if (!String.IsNullOrEmpty(userName))
            {
                m = from a in db.m_user
                    join b in db.m_worker
                    on a.user_id equals b.work_id into temp
                    from b in temp.DefaultIfEmpty()
                    where b.work_name.Contains(userName)
                    select new
                    {
                        a.user_id,
                        a.position,
                        b.work_name
                    };
            }

            //m = m.OrderBy(r => priorityDict[r.position]);
            //var m2 = m.AsEnumerable().OrderBy(r => priorityDict[r.position]);
            
            var m2 = m.AsEnumerable().OrderBy(r =>
            {
                try
                {
                    return priorityDict[r.position];
                }
                catch (KeyNotFoundException)
                {
                    return int.MaxValue; // not in 1-6 max
                }
            }
            ).ThenBy(r => r.user_id); 
            


            List<UserModel> List = new List<UserModel>();
            int i = 0;
            foreach (var item in m2)
            {
                List.Insert(i, new UserModel());
                List[i].UserId = item.user_id;
                List[i].UserNm = item.work_name;
                i++;
            }


            return List.Distinct().ToList();
        }
    }
}
