﻿/*! ========================================================================
/* SelectBox変更時、値を元に戻すjs
 * 
 * SelectBoxで、変更時ポップアップが表示される処理で、
 * 「キャンセル」が押された場合、SelectBoxの値を基に戻す
 * 
 * ======================================================================== */
(function ($) {
    $.fn.exChange = function (callback, fn) {

        let $sel = $(this);

        // 値取得用関数定義（なければvalueをとる）
        var func = fn || function () { return $sel.val(); };

        $sel.each(function () {

            // イベントバインド時に入力内容を保持
            var val = func.apply(this);

            // changeイベントにバインド
            $sel.change(function () {

                // 発火前にargumentsの末尾に変更前の値を入れる
                Array.prototype.push.call(arguments, val);

                // イベントを発火
                callback.apply(this, arguments);

                // 終わったら更新しておく
                val = func($sel);
            });
        });
    }
})(jQuery); 