﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace ChangePointSystem.Util
{
    public static class Const
    {

        /// <summary>
        /// 削除フラグ 0:未削除
        /// </summary>
        public static readonly String DELETE_FLG_OFF = "0";

        /// <summary>
        /// 削除フラグ 1:削除
        /// </summary>
        public static readonly String DELETE_FLG_ON = "1";

        /// <summary>
        /// 4M区分 1:人
        /// </summary>
        public static readonly String CHANGE_TYPE_MAN = "1";

        /// <summary>
        /// 4M区分 2:設備
        /// </summary>
        public static readonly String CHANGE_TYPE_MACHINE = "2";

        /// <summary>
        /// 4M区分 3:材料
        /// </summary>
        public static readonly String CHANGE_TYPE_MATERIAL = "3";

        /// <summary>
        /// 4M区分 4:方法
        /// </summary>
        public static readonly String CHANGE_TYPE_METHOD = "4";

        /// <summary>
        /// 対応状況 00:未登録
        /// </summary>
        public static readonly String DEAL_STATUS_CODE_NOT_REGISTE = "00";

        /// <summary>
        /// 対応状況 10:登録済
        /// </summary>
        public static readonly String DEAL_STATUS_CODE_REGISTE = "10";

        /// <summary>
        /// 対応状況 20:教育確認NG
        /// </summary>
        public static readonly String DEAL_STATUS_CODE_TRAINING_NG = "20";

        /// <summary>
        /// 対応状況 29:教育確認済
        /// </summary>
        public static readonly String DEAL_STATUS_CODE_TRAINING = "29";

        /// <summary>
        /// 対応状況 30:L長確認待ち
        /// </summary>
        public static readonly String DEAL_STATUS_CODE_WAITE_CONFIRM = "30";

        /// <summary>
        /// 対応状況 40:検査確認NG
        /// </summary>
        public static readonly String DEAL_STATUS_CODE_CHECK_NG = "40";

        /// <summary>
        /// 対応状況 49:検査確認済
        /// </summary>
        public static readonly String DEAL_STATUS_CODE_CHECK = "49";

        /// <summary>
        /// 対応状況 50:最終確認済NG
        /// </summary>
        public static readonly String DEAL_STATUS_CODE_FINAL_CONFIRM_NG = "50";

        /// <summary>
        /// 対応状況 59:最終確認済
        /// </summary>
        public static readonly String DEAL_STATUS_CODE_FINAL_CONFIRM = "59";

        /// <summary>
        /// 対応状況 60:管理者承認済
        /// </summary>
        public static readonly String DEAL_STATUS_CODE_FINAL_APPROVED = "60";

        /// <summary>
        /// 登録状態 0:未登録
        /// </summary>
        public static readonly String REGISTE_STATUS_NOT_REGISTE = "0";

        /// <summary>
        /// 登録状態 1:登録済
        /// </summary>
        public static readonly String REGISTE_STATUS_REGISTE = "1";

        /// <summary>
        /// 採番区分 001:管理No
        /// </summary>
        public static readonly String NUMBER_TYPE_MANAGE_NO = "001";

        /// <summary>
        /// カンマ区切り（Char）
        /// </summary>
        public static readonly char SPLIT_COMMA_CHAR = ',';

        /// <summary>
        /// カンマ区切り(String)
        /// </summary>
        public static readonly String SPLIT_COMMA_STRING = ",";

        /// <summary>
        /// 教育区分 1:教育結果
        /// </summary>
        public static readonly String TRAINING_TYPE = "1";

        /// <summary>
        /// 検査区分 2:検査結果
        /// </summary>
        public static readonly String CHECK_TYPE2 = "2";

        /// <summary>
        /// 確認結果 1:OK
        /// </summary>
        public static readonly String CONFIRM_RESULT_OK = "1";

        /// <summary>
        /// 確認結果 9:NG
        /// </summary>
        public static readonly String CONFIRM_RESULT_NG = "9";

        /// <summary>
        /// 前後区分 1:前
        /// </summary>
        public static readonly String BEFORE_CODE = "1";

        /// <summary>
        /// 前後区分 2:後
        /// </summary>
        public static readonly String AFTER_CODE = "2";

        /// <summary>
        /// 前後区分 3:前・後
        /// </summary>
        public static readonly String BEFORE_AFTER_CODE = "3";

        /// <summary>
        /// 前後区分 9:その他
        /// </summary>
        public static readonly String BEFORE_AFTER_OTHER_CODE = "9";

        /// <summary>
        /// 職位 4:ライン長
        /// </summary>
        public static readonly String POSITION_LINE_LEADER = "4";

        /// <summary>
        /// 職位 3:リーダー
        /// </summary>
        public static readonly String POSITION_LEADER = "3";

        /// <summary>
        /// エフ取外確認 0:未取外
        /// </summary>
        public static readonly String EFU_REMOVE_NOT = "0";

        /// <summary>
        /// エフ取外確認 1:取外済
        /// </summary>
        public static readonly String EFU_REMOVE_OK = "1";

        /// <summary>
        /// file確認結果 0:合格
        /// </summary>
        public static readonly String FILE_RESULT_OK = "0";

        /// <summary>
        /// file確認結果 1:手直し合格
        /// </summary>
        public static readonly String FILE_RESULT_REOK = "1";

        /// <summary>
        /// file確認結果 2:NG
        /// </summary>
        public static readonly String FILE_RESULT_NG = "2";

        /// <summary>
        /// file確認結果 3:廃棄
        /// </summary>
        public static readonly String FILE_RESULT_NO = "3";

        /// <summary>
        /// 4M区分 表示ラベル
        /// </summary>
        public static readonly Dictionary<String, String> CHANGE_TYPE_CODE_LABEL =
            new Dictionary<string, string>() {
                {"1","人"},
                {"2","設備"},
                {"3","材料"},
                {"4","方法"}
            };

        /// <summary>
        /// 対応状況 表示ラベル
        /// </summary>
        public static readonly Dictionary<String, String> DEAL_STATUS_CODE_LABEL =
            new Dictionary<string, string>() {
                {"00","未登録"},
                {"10","登録済"},
                {"20","教育確認NG"},
                {"29","教育確認済"},
                {"30","L長確認待ち"},
                {"40","検査確認NG"},
                {"49","検査確認済"},
                {"50","最終確認NG"},
                {"59","最終確認済"},
                {"60","管理者承認済"}
            };

        /// <summary>
        /// 登録状態 表示ラベル
        /// </summary>
        public static readonly Dictionary<String, String> REGISTE_STATUS_CODE_LABEL =
            new Dictionary<string, string>() {
                {"0","未登録"},
                {"1","登録済"}
            };

        /// <summary>
        /// 確認結果 表示ラベル
        /// </summary>
        public static readonly Dictionary<String, String> CONFIRM_RESULT_CODE_LABEL =
            new Dictionary<string, string>() {
                {"1","OK"},
                {"9","NG"}
            };

        /// <summary>
        /// 前後区分 表示ラベル
        /// </summary>
        public static readonly Dictionary<String, String> BEFORE_AFTER_CODE_LABEL =
            new Dictionary<string, string>() {
                {"1","前"},
                {"2","後"},
                {"3", "前・後" },
                {"9", "その他" }
            };

        /// <summary>
        /// 検索条件区分 表示ラベル
        /// </summary>
        public static readonly Dictionary<String, String> SEARCH_TYPE_CODE_LABEL =
            new Dictionary<string, string>() {
                {"1","履歴検索"},
                {"2","予定検索"},
                {"3","詳細検索"}
            };

        /// <summary>
        /// 前／後工程区分 表示ラベル
        /// </summary>
        public static readonly Dictionary<String, String> WORK_TYPE_CODE_LABEL =
            new Dictionary<string, string>() {
                {"1","前工程"},
                {"2","後工程"},
                {"9","その他"}
            };

        /// <summary>
        /// ステータス範囲区分 表示ラベル
        /// </summary>
        public static readonly Dictionary<String, String> RANGE_TYPE_CODE_LABEL =
            new Dictionary<string, string>() {
                {"1","以前"},
                {"2","以後"},
                {"3","等しい"}
            };
    }
}