﻿using ChangePointSystem.Models;
using ChangePointSystem.Repository;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Net.Mail;
using System.Security.Cryptography;
using System.Text;
using System.Web;
using System.Web.Mvc;
using System.Web.SessionState;

namespace ChangePointSystem.Util
{
    public class Util
    {

        // 初期化ベクトル
        private const string AesIV = "VwRznaaEarbfVJ63";

        // 暗号化鍵
        private const string AesKey = "nkeC9J4FWLRhkaZFaYt3sN3J4sSxwxNs";

        /// <summary>
        /// 暗号化
        /// </summary>
        /// <param name="str">暗号化したい文字列</param>
        /// <returns>暗号化された文字列</returns>
        public String Encrypt(String str)
        {
            //nullの時は空文字を返す
            if (str == null)
            {
                return "";
            }

            // 暗号化方式はAES
            AesManaged aes = new AesManaged();

            // 鍵の長さ
            aes.KeySize = 256;
            // ブロックサイズ（何文字単位で処理するか）
            aes.BlockSize = 128;

            // 暗号利用モード
            aes.Mode = CipherMode.CBC;
            aes.IV = Encoding.UTF8.GetBytes(AesIV);
            aes.Key = Encoding.UTF8.GetBytes(AesKey);

            // パディング
            aes.Padding = PaddingMode.PKCS7;

            // 暗号化するためにはバイトの配列に変換する必要がある
            byte[] byteText = Encoding.UTF8.GetBytes(str);

            // 暗号化
            byte[] encryptText = aes.CreateEncryptor().TransformFinalBlock(byteText, 0, byteText.Length);

            // Base64形式（64種類の英数字で表現）で返す
            return UrlEncode(Convert.ToBase64String(encryptText));
        }

        /// <summary>
        /// 複合化
        /// <param name="str">復号したい文字列</param>
        /// <return>復号された文字列</return>
        /// </summary>
        public String Decrypt(String str)
        {
            //nullの時は空文字を返す
            if (str == null)
            {
                return "";
            }

            // 暗号化方式はAES
            AesManaged aes = new AesManaged();

            // 鍵の長さ
            aes.KeySize = 256;
            // ブロックサイズ（何文字単位で処理するか）
            aes.BlockSize = 128;

            // 暗号利用モード
            aes.Mode = CipherMode.CBC;
            aes.IV = Encoding.UTF8.GetBytes(AesIV);
            aes.Key = Encoding.UTF8.GetBytes(AesKey);

            // パディング
            aes.Padding = PaddingMode.PKCS7;

            //URLを戻す
            byte[] byteText = Convert.FromBase64String(UrlDecode(str));

            // 複合化
            byte[] decryptText = aes.CreateDecryptor().TransformFinalBlock(byteText, 0, byteText.Length);
            
            return Encoding.UTF8.GetString(decryptText);
        }

        /// <summary>
        /// +等の変換されてしまう文字列を変換されない文字列にする
        /// <param name="str">置換したい文字列</param>
        /// <return>置換された文字列</return>
        /// </summary>
        private String UrlEncode(String str)
        {
            return str.Replace("+", "_").Replace("=", "-").Replace("/", "~");

        }

        /// <summary>
        /// UrlEncodeの結果を戻す
        /// <param name="str">置換された文字列</param>
        /// <return>デコードされた文字列</return>
        /// </summary>
        private String UrlDecode(String str)
        {
            return str.Replace("_", "+").Replace("-", "=").Replace("~", "/");

        }

        /// <summary>
        /// ModelのErrorKeyのリストを返す
        /// </summary>
        /// <param name="modelState">モデルの状態</param>
        /// <returns></returns>
        public List<String> getModelErrorKeyList(ModelStateDictionary modelState)
        {
            List<String> keyList = new List<String>();

            foreach (var modelStateKey in modelState.Keys)
            {
                var modelStateVal = modelState[modelStateKey];
                foreach (var error in modelStateVal.Errors)
                {
                    keyList.Add(modelStateKey);
                    
                }
            }

            return keyList;

        }

        #region Setセッション
        /// <summary>
        /// セッションにデータが入っていなかった場合、
        /// ログイン情報をセッションに入れる
        /// </summary>
        public void SetSessionUser(m_user entity, String userName)
        {
            //テーブルからユーザ情報を取得し、セッションに入れる
            System.Web.HttpContext.Current.Session["User"] = new UserModel(entity, userName);

        }
        #endregion

        #region メールアドレスチェック
        /// <summary>
        /// メールアドレスかどうかチェックを行う
        /// </summary>
        /// <param name="val">値</param>
        /// <returns></returns>
        public bool IsMailAddress(String val)
        {
            try
            {
                new MailAddress(val);
                return true;
            }
            catch
            {
                //エラーになった場合、メールアドレスではない
                return false;
            }

        }
        #endregion

    }
}